define("io.ox/office/presentation/utils/presentationutils",["io.ox/office/tk/utils","io.ox/office/drawinglayer/utils/drawingutils","io.ox/office/drawinglayer/view/drawingframe","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom","io.ox/office/textframework/utils/position","io.ox/office/tk/render/rectangle","gettext!io.ox/office/presentation/main"],function(t,e,i,r,n,o,a,l){"use strict";var p={};return p.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS=["left","top","width","height","rotation","flipH","flipV"],p.DEFAULT_PLACEHOLDER_TYPE="body",p.TABLE_PLACEHOLDER_TYPE="tbl",p.IMAGE_PLACEHOLDER_TYPE="pic",p.CONTENTBODY="contentbody",p.TITLE_PLACEHOLDER_TYPES={title:1,ctrTitle:1},p.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES={title:1,ctrTitle:1,subTitle:1},p.ODF_MASTER_READONLY_TYPES={title:1,body:1},p.NO_TEXT_PLACEHOLDER_TYPE={media:1,clipArt:1,chart:1,dgm:1,tbl:1,pic:1},p.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY={media:null,clipArt:"image",chart:null,dgm:null,tbl:"table",pic:"image"},p.PLACEHOLDER_TEMPLATE_TEXTS={body:l("Click to add text"),title:l("Click to add title"),ctrTitle:l("Click to add title"),subTitle:l("Click to add subtitle"),media:l("Media clip"),clipArt:l("Online image"),chart:l("Chart"),dgm:l("Smart Art"),tbl:l("Click to add table"),pic:l("Click to add image"),sldNum:l("Slide Number"),ftr:l("Footer"),dt:l("Date")},p.PLACEHOLDER_TEMPLATE_TEXTS_ODF={body:l("Click to add text"),title:l("Click to add title"),ctrTitle:l("Click to add title"),subTitle:l("Click to add text"),media:l("Media clip"),clipArt:l("Online image"),chart:l("Chart"),dgm:l("Smart Art"),tbl:l("Click to add table"),pic:l("Click to add image"),sldNum:l("Slide Number"),ftr:l("Footer"),dt:l("Date")},p.PLACEHOLDER_TEMPLATE_TEXTS_CLICK={pic:l("Click icon to add image"),tbl:l("Click icon to add table"),chart:l("Click icon to add chart"),dgm:l("Click icon to add smart art graphic"),clipArt:l("Click icon to add clip art"),media:l("Click icon to add media")},p.PLACEHOLDER_TEMPLATE_BUTTONS={contentBody:["picture","table"],body:null,title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},p.PLACEHOLDER_TEMPLATE_BUTTONS_ODF={contentBody:["picture","table"],body:["picture","table"],title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},p.PLACEHOLDER_DRAWING_NAMES={content:l("Content placeholder"),contentv:l("Vertical content placeholder"),text:l("Text placeholder"),textv:l("Vertical text placeholder"),picture:l("Image placeholder"),table:l("Table placeholder")},p.PLACEHOLDER_TEXT_CONTENT=[l("Edit Master text styles"),l("Second level"),l("Third level"),l("Fourth level"),l("Fifth level")],p.PLACEHOLDER_TITLE_CONTENT=l("Click to edit Master title style"),p.DEFAULT_PLACEHOLDER_INDEX=0,p.isPlaceHolderAttributeSet=function(t){return!(!t||!t.presentation||!t.presentation.phType&&!_.isNumber(t.presentation.phIndex))},p.isTitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&p.TITLE_PLACEHOLDER_TYPES[t.presentation.phType])},p.isTitleOrSubtitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&p.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES[t.presentation.phType])},p.isBodyPlaceHolderAttributeSet=function(t){return!(!(t&&t.presentation&&_.isNumber(t.presentation.phIndex))||t.presentation.phType!==p.DEFAULT_PLACEHOLDER_TYPE&&t.presentation.phType)},p.isTextBodyPlaceHolderAttributeSet=function(t,e){return!(e||!1||!t||!t.presentation||!_.isNumber(t.presentation.phIndex)||t.presentation.phType!==p.DEFAULT_PLACEHOLDER_TYPE)},p.isContentBodyPlaceHolderAttributeSet=function(t,e){var i=e||!1;return!(!t||!t.presentation||!_.isNumber(t.presentation.phIndex)&&!i||t.presentation.phType&&(!i||t.presentation.phType!==p.DEFAULT_PLACEHOLDER_TYPE))},p.isPlaceHolderWithoutTextAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&p.NO_TEXT_PLACEHOLDER_TYPE[t.presentation.phType])},p.isCustomPromptPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.customPrompt)},p.isODFReadOnlyPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&p.ODF_MASTER_READONLY_TYPES[t.presentation.phType])},p.isBodyPlaceHolderAttributeSetWithoutIndex=function(t){return!(!t||!t.presentation||_.isNumber(t.presentation.phIndex)||t.presentation.phType!==p.DEFAULT_PLACEHOLDER_TYPE)},p.isUserModifiedPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.userTransformed)},p.isPlaceHolderDrawing=function(t){return p.isPlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.getPlaceHolderDrawingType=function(t,e){var i=e||r.getExplicitAttributes(t);return i&&i.presentation&&i.presentation.phType?i.presentation.phType:null},p.getPlaceHolderDrawingIndex=function(t,e){var i=e||r.getExplicitAttributes(t);return i&&i.presentation&&_.isNumber(i.presentation.phIndex)?i.presentation.phIndex:null},p.isTitlePlaceHolderDrawing=function(t){return p.isTitlePlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.isTitleOrSubtitlePlaceHolderDrawing=function(t){return p.isTitleOrSubtitlePlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.isBodyPlaceHolderDrawing=function(t){return p.isBodyPlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.isTextBodyPlaceHolderDrawing=function(t){return p.isTextBodyPlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.isContentBodyPlaceHolderDrawing=function(t){return p.isContentBodyPlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.isPlaceHolderWithoutTextDrawing=function(t){return p.isPlaceHolderWithoutTextAttributeSet(r.getExplicitAttributes(t))},p.isEmptyPlaceHolderDrawing=function(t){var e=r.getExplicitAttributes(t),i=!1,o=null;return p.isPlaceHolderWithoutTextAttributeSet(e)?"undefined"!==$(t).attr("data-type")&&(o=p.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY[e.presentation.phType],e&&o&&e[o]||(i=!0)):p.isPlaceHolderAttributeSet(e)&&(i=n.isEmptyTextframe(t,{ignoreTemplateText:!0})),i},p.isCustomPromptPlaceHolderDrawing=function(t){return p.isCustomPromptPlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.isODFReadOnlyPlaceHolderDrawing=function(t){return p.isODFReadOnlyPlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.isBodyPlaceHolderWithoutIndexDrawing=function(t){return p.isBodyPlaceHolderAttributeSetWithoutIndex(r.getExplicitAttributes(t))},p.isUserModifiedPlaceHolderDrawing=function(t){return p.isUserModifiedPlaceHolderAttributeSet(r.getExplicitAttributes(t))},p.requiresUserTransformedProperty=function(t){var e=r.getExplicitAttributes(t);return p.isPlaceHolderAttributeSet(e)&&!p.isUserModifiedPlaceHolderAttributeSet(e)},p.getDrawingModelDescriptor=function(e,i){var o=r.getExplicitAttributes(e),a=t.getBooleanOption(i,"useDefaultValues",!0),l=null;return p.isPlaceHolderAttributeSet(o)&&((l={}).target=n.getTargetContainerId($(e).parent()),l.type=o.presentation.phType,l.index=o.presentation.phIndex,a&&(l.type&&!_.isNumber(l.index)&&(l.index=p.DEFAULT_PLACEHOLDER_INDEX),_.isNumber(l.index)&&!l.type&&(l.type=p.DEFAULT_PLACEHOLDER_TYPE))),l},p.getValidTypeIndexSet=function(e){return e&&e.presentation&&("phType"in e.presentation||"phIndex"in e.presentation)?{type:t.getStringOption(e.presentation,"phType",p.DEFAULT_PLACEHOLDER_TYPE),index:t.getIntegerOption(e.presentation,"phIndex",p.DEFAULT_PLACEHOLDER_INDEX)}:null},p.getPlaceHolderTemplateText=function(t,e){var i=p.getPlaceHolderDrawingType(t),r=e||!1;return!i&&_.isNumber(p.getPlaceHolderDrawingIndex(t))&&(i=p.DEFAULT_PLACEHOLDER_TYPE),i?r?p.PLACEHOLDER_TEMPLATE_TEXTS_ODF[i]:p.PLACEHOLDER_TEMPLATE_TEXTS[i]:null},p.getPlaceHolderTemplateButtonsList=function(t,e){return(e?p.PLACEHOLDER_TEMPLATE_BUTTONS_ODF:p.PLACEHOLDER_TEMPLATE_BUTTONS)[t||"contentBody"]},p.getODFFooterRepresentation=function(t){var e=p.PLACEHOLDER_TEMPLATE_TEXTS_ODF[t];return e?"<"+e+">":""},p.convertAppContentBoxToOperationBox=function(e,i,r){var n=e.getView().getZoomFactor(),o=e.getModel().getSlideById(e.getModel().getActiveSlideId()).offset(),a=e.getView().getContentRootNode(),l=a.offset(),p=a.scrollLeft(),c=a.scrollTop(),d={},s=!!_.isBoolean(r)&&r;return d.left=(i.left-(o.left-l.left)-p)/n,d.top=(i.top-(o.top-l.top)-c)/n,d.width=s?i.width:t.round(i.width/n,1),d.height=s?i.height:t.round(i.height/n,1),d.left=t.convertLengthToHmm(d.left,"px"),d.top=t.convertLengthToHmm(d.top,"px"),d.width=t.convertLengthToHmm(d.width,"px"),d.height=t.convertLengthToHmm(d.height,"px"),d.left<0&&(d.left=0),d},p.extendPlaceholderProp=function(t,e,i){if(i&&i.attrs&&i.attrs.drawing){var n=r.getExplicitAttributes(e);if(p.isPlaceHolderAttributeSet(n)){var o=t.getModel().getDrawingStyles().getElementAttributes(e).drawing;_.each(o,function(t,e){e in i.attrs.drawing||!_.contains(p.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS,e)||e in n.drawing||(i.attrs.drawing[e]=t)})}}},p.checkEventPosition=function(t,e,o,a){var l=!0,c=t.getModel(),d=null,s=null;if(n.isTextSpan(e.target)||n.isParagraphNode(e.target))return l;if(e.target&&$(e.target.parentNode).is(".borders"))return l;if(p.isPlaceHolderDrawing(o))return l;if(i.isGroupDrawingFrame(o))return!l;if(!i.isShapeDrawingFrame(o))return l;var u=i.getCanvasNode(o);if(!u||0===u.length)return l;var g=a||r.getExplicitAttributes(o,{family:"drawing"}),T=c.getActiveSlide().offset(),E=0,f=0,h=0,A=0,P=0,L=0,m=g.flipH,x=g.flipV,b=p.normalizeRotationAndGrouping(t,o,e,T),D=b.rect;if(!b.point)return l;h=D.left,A=D.top,P=D.width,L=D.height,E=b.point.left,f=b.point.top,E-=h,f-=A,m&&(E=P-E),x&&(f=L-f),d=Math.max(E-6,0),s=Math.max(f-6,0);var H=u[0].getContext("2d").getImageData(d,s,12,12);return l=!_.every(H.data,function(t){return 0===t})},p.findValidDrawingNodeBehindDrawing=function(t,e,r){for(var n=0,o=!1,a=(i.isGroupedDrawingFrame(r)?i.getGroupNode(r,{farthest:!0,rootNode:t.getModel().getCurrentRootNode()}):r).prevAll(".drawing"),l=a.length,c=null;n<l&&!o;){var d=$(a[n]);n++,(c=p.checkEventPositionInDrawing(t,e.pageX,e.pageY,d))&&(o=!0)}return c},p.checkEventPositionInDrawing=function(n,o,l,c){function d(e,i,r){var n=Math.round(t.convertCssLength(e.css("left"),"px")),o=Math.round(t.convertCssLength(e.css("top"),"px")),l=e.width(),p=e.height(),c=r.flipH,d=r.flipV;return c&&(n=i.width-l-n),d&&(o=i.height-p-o),n+=i.left,o+=i.top,new a(n,o,l,p)}function s(t,r,a){if(i.isTextFrameShapeDrawingFrame(t)&&(L=i.getTextFrameNode(t))){var c=d(L,a,r);e.pointInsideRect({x:h,y:A},c,1)?(m=t,x=!0,b={rect:c,posX:h,posY:A}):L=null}x||p.checkEventPosition(n,{pageX:o,pageY:l,target:null},t,r)&&(m=t,x=!0)}var u=n.getModel().getActiveSlide().offset(),g=r.getExplicitAttributes(c,{family:"drawing"}),T=p.normalizeRotationAndGrouping(n,c,{pageX:o,pageY:l},u),E=T.rect,f=T.drawingRect,h=T.point.left,A=T.point.top,P=n.getView().getZoomFactor(),L=null,m=null,x=!1,b=null;return e.pointInsideRect({x:h,y:A},E,6)&&(i.isGroupDrawingFrame(c)?_.each(c.find(".drawing"),function(t){if(!i.isGroupDrawingFrame(t)){t=$(t);var a=p.normalizeRotationAndGrouping(n,t,{pageX:o,pageY:l},u),c=a.rect,d=a.drawingRect;h=a.point.left,A=a.point.top;var g=r.getExplicitAttributes(t,{family:"drawing"});e.pointInsideRect({x:h,y:A},c,6)&&s(t,g,d)}}):i.isTableDrawingFrame(c)?function(t){var i=null,r=_.find(t.find("div.cell"),function(t){var r=(t=$(t)).offset(),n=(r.left-u.left)/P,o=(r.top-u.top)/P;return i=new a(n,o,t.width(),t.height()),e.pointInsideRect({x:h,y:A},i,1)});r&&(m=t,L=r,x=!0,b={rect:i,posX:h,posY:A})}(c):s(c,g,f)),x?{drawing:m,textFrameNode:L,info:b}:null},p.normalizeRotationAndGrouping=function(n,o,l,p){function c(e,r){var o=0,l=0,p=i.isGroupedDrawingFrame(e);_.isNumber(r.left)&&_.isNumber(r.top)||(r=n.getModel().getDrawingStyles().getElementAttributes(e).drawing),p?(o=Math.round(t.convertCssLength(e.css("left"),"px")),l=Math.round(t.convertCssLength(e.css("top"),"px"))):(o=t.convertHmmToLength(r.left,"px",1),l=t.convertHmmToLength(r.top,"px",1)),o+=f,l+=h;var c=e.width(),d=e.height();return new a(o,l,c,d)}var d=n.getView().getZoomFactor(),s=i.isGroupedDrawingFrame(o),u=!!l,g=p||{left:0,top:0},T=0,E=0,f=0,h=0,A=0,P=!1,L=r.getExplicitAttributes(o,{family:"drawing"}),m=L.rotation,x=o.children(".canvasexpansion").length>0,b=null,D=null;return u&&(_.isNumber(l.pageX)&&_.isNumber(l.pageY)?(T=(l.pageX-g.left)/d,E=(l.pageY-g.top)/d):P=!0),s&&function(n){var o=[];for(o.push(i.getGroupNode(n));i.isGroupedDrawingFrame(_.last(o));)o.push(i.getGroupNode(_.last(o)));o=o.reverse(),_.each(o,function(i){var n=r.getExplicitAttributes(i,{family:"drawing"}),o=null;u&&_.isNumber(n.rotation)&&(o=c(i,n),A=e.rotatePointWithAngle(o.centerX(),o.centerY(),T,E,n.rotation),T=A.left,E=A.top),f+=Math.round(t.convertCssLength(i.css("left"),"px")),h+=Math.round(t.convertCssLength(i.css("top"),"px"))})}(o),D=c(o,L),u&&_.isNumber(m)&&0!==m&&(A=e.rotatePointWithAngle(D.centerX(),D.centerY(),T,E,m),T=A.left,E=A.top),x&&function(e,i,r){var n=r.width(),o=r.height(),a=i.flipH,l=i.flipV,p=0,c=0;p=a?-(n-e.width+Math.round(t.convertCssLength(r.css("left"),"px"))):Math.round(t.convertCssLength(r.css("left"),"px")),c=l?-(o-e.height+Math.round(t.convertCssLength(r.css("top"),"px"))):Math.round(t.convertCssLength(r.css("top"),"px")),b=_.copy(e),e.left+=p,e.top+=c,e.width=n,e.height=o}(D,L,i.getCanvasNode(o)),{rect:D,drawingRect:b||D,point:P?null:{left:T,top:E}}},p.getBackgroundTextPosition=function(t,e,r,n){var a=null,l=t.getModel().getCurrentRootNode();if((r=$(r)).parent().is(".emptytextframe"))a=o.getLastTextPositionInTextFrame(l,e);else{var p=r.find("div.p"),c=r.offset();_.each(p,function(e){if(!a){var i=$(e).offset(),r=(i.left-c.left)/t.getView().getZoomFactor(),p=(i.top-c.top)/t.getView().getZoomFactor(),d=n.posX-n.rect.left-r,s=n.posY-n.rect.top-p,u=o.getPositionInsideParagraph(l,e,d,s,100*t.getView().getZoomFactor());u&&u.pos&&(a=u.pos)}})}return a=a||(i.isTableDrawingFrame(e)?o.getLastTextPositionInTableCell(l,r):o.getLastTextPositionInTextFrame(l,e))},p});