define("io.ox/office/spreadsheet/controller/chartmixin",["io.ox/office/tk/utils","io.ox/office/drawinglayer/view/drawinglabels","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/view/chartcreator","gettext!io.ox/office/spreadsheet/main"],function(t,e,r,n,a){"use strict";return function(i){function u(e){switch(e){case"sheets":i.yell({type:"warning",message:a("Data references are located on different sheets.")});break;case"directions":i.yell({type:"warning",message:a("Data references are too complex for this operation.")});break;default:t.warn('DrawingController.yellChartDirection(): unknown warning type: "'+e+'"')}return $.Deferred().reject()}function l(){var t=i.getSelectedDrawings();return 1===t.length?t[0]:null}function s(t){var e=l();if(e)return i.getDrawingCollection().getModel(e,{type:t})}function o(t,e,r,n){return i.getSheetModel().createAndApplyOperations(function(a){var i=l();return T.convertToPromise(n?n(a,i):null).done(function(){c(a,t,e,i,r)})},{storeSelection:!0})}function c(e,n,a,i,u){var l=null;switch(a){case r.SET_CHART_LEGEND_ATTRIBUTES:l={attrs:n.getLegendModel(u.axis).getUndoAttributeSet(u.attrs)};break;case r.SET_CHART_TITLE_ATTRIBUTES:var s=null===u.axis||void 0===u.axis?null:u.axis;l={attrs:n.getTitleModel(s).getUndoAttributeSet(u.attrs)},null!==s&&(l.axis=s);break;case r.SET_CHART_AXIS_ATTRIBUTES:var o=n.getAxisModel(u.axis);l={axis:u.axis,axPos:u.axPos,crossAx:u.crossAx,attrs:o.getUndoAttributeSet(u.attrs)};break;case r.SET_CHART_GRIDLINE_ATTRIBUTES:var c=n.getAxisModel(u.axis).getGrid();l={axis:u.axis,attrs:c.getUndoAttributeSet(u.attrs)};break;case r.CHANGE_DRAWING:l={attrs:n.getUndoAttributeSet(u.attrs)};break;default:return void t.error('generateChartOperation(): unknown operation "'+a+'"')}e.generateDrawingOperation(a,i,l,{undo:!0}),e.generateDrawingOperation(a,i,u)}function g(t){return _.isObject(t)&&_.isArray(t.text.link)?(t.text.link[0]||"").trim():""}function d(t,e,n){var a={attrs:n};return null!==e&&(a.axis=e),o(t,r.SET_CHART_TITLE_ATTRIBUTES,a)}function h(t,e,r){return d(t,e,{text:{link:[r]},character:n.getHeadChar(x)})}function f(t,e){if(!t)return!1;var r=t.getDataSourceInfo();return!r.warn&&(r.axis&&(e=Math.abs(e-1)),1===e?b(t):t.isNamesLabel()||t.getSeriesCount()>1)}function w(t,e){if(!t)return!1;var r=t.getDataSourceInfo();return!r.warn&&(r.axis&&(e=Math.abs(e-1)),1===e?t.isTitleLabel():t.isNamesLabel())}function p(t,e,r){if(!t)return null;var a=t.getDataSourceInfo();if(a.warn)return null;a.axis&&(e=Math.abs(e-1));var i,u;return 1===e?(u=t.isNamesLabel(),i=r):(u=r,i=t.isTitleLabel()),n.updateSeries({app:v,sourceRange:a.range,sourceSheet:a.sheet,chartModel:t,axis:a.axis,forceTitle:i,forceNames:u})}function b(t){if(t.isTitleLabel())return!0;var e=1;return t.isAreaOrLine()&&(e=2),t.getFirstPointsCount()>e}function S(t){var e=t.getDataSourceInfo();if(e.warn)return u(e.warn);var r=t.isNamesLabel(),a=t.isTitleLabel();return n.updateSeries({app:v,sourceRange:e.range,sourceSheet:e.sheet,chartModel:t,axis:1-e.axis,forceTitle:r,forceNames:a,switchRowColumn:!0})}var T=this,v=this.getApp(),x=i.getDocModel();this.registerDefinitions({"chart/insert":{parent:"drawing/insert/enable",enable:function(){var t=i.getSelectedRanges();return 1===t.length&&!i.getSheetModel().isSingleCellInRange(t[0])},set:function(t){return n.createChart(v,e.CHART_TYPE_STYLES[t])}},"drawing/chart":{parent:"drawing/operation",enable:function(){return _.isObject(this.getValue())},get:function(){return s("chart")}},"drawing/chart/valid":{parent:"drawing/chart",enable:function(t){return t.isRestorable()}},"drawing/chartlabels":{parent:"drawing/chart/valid",get:function(){return i.getChartLabelsMenu().isVisible()},set:function(t){i.getChartLabelsMenu().toggle(t)}},"drawing/chartexchange":{parent:"drawing/chart/valid",enable:function(t){var e=0;return t.isAreaOrLine()&&(e=1),t.getSeriesCount()>e},set:function(){return S(this.getParentValue())}},"drawing/chartfirstcol":{parent:"drawing/chart/valid",enable:function(t){return f(t,0)},get:function(t){return w(t,0)},set:function(t){return p(this.getParentValue(),0,t)}},"drawing/chartfirstrow":{parent:"drawing/chart/valid",enable:function(t){return f(t,1)},get:function(t){return w(t,1)},set:function(t){return p(this.getParentValue(),1,t)}},"drawing/charttype":{parent:"drawing/chart/valid",get:function(t){return t?t.getChartTypeForGui():null},set:function(t){var r=s("chart"),a=e.CHART_TYPE_STYLES[t],i=r.getDataSourceInfo();if(i.warn)return u(i.warn);var l;return r.isXYType()&&(l=r.isNamesLabel()),n.updateSeries({app:v,sourceRange:i.range,sourceSheet:i.sheet,chartModel:r,axis:i.axis,chartData:a,forceNames:l})}},"drawing/chart/attributes":{parent:"drawing/chart/valid",get:function(t){return t?t.getMergedAttributeSet(!0):null}},"drawing/chartvarycolor":{parent:["drawing/chart/valid","drawing/chart/attributes"],enable:function(t){return t.isVaryColorEnabled()},get:function(t){return t?t.isVaryColor():null},set:function(t){return this.getParentValue().changeVaryColors(t)}},"drawing/chartdatalabel":{parent:"drawing/chart/valid",get:function(t){return t?!_.isEmpty(t.getDataLabel()):null},set:function(t){return this.getParentValue().setDataLabel(t)}},"drawing/chartcolorset":{parent:"drawing/chart/valid",get:function(t){return t?t.getColorSet():null},set:function(t){return this.getParentValue().changeColorSet(t)}},"drawing/chartstyleset":{parent:"drawing/chart/valid",get:function(t){return t?t.getStyleSet():null},set:function(t){return this.getParentValue().changeStyleSet(t)}},"drawing/chartdatasource":{parent:"drawing/chart/valid"},"drawing/chartsource":{parent:"drawing/chart/valid",get:function(){return!1},set:function(){i.enterCustomSelectionMode("chartsource",{statusLabel:a("Select source data")}).done(function(t){var e=t.ranges[0],r=i.getActiveSheet(),a=s("chart"),u=a.getDataSourceInfo();if(u.warn)return n.updateSeries({app:v,sourceRange:e,sourceSheet:r,chartModel:a});var l;return a.isXYType()&&(l=a.isNamesLabel()),n.updateSeries({app:v,sourceRange:e,sourceSheet:r,chartModel:a,axis:u.axis,forceNames:l})})},enable:function(){return!t.TOUCHDEVICE}},"drawing/chartlegend/pos":{parent:"drawing/chart/valid",get:function(t){return t?t.getLegendModel().getMergedAttributeSet(!0).legend.pos:null},set:function(t){return o(this.getParentValue(),r.SET_CHART_LEGEND_ATTRIBUTES,{attrs:{legend:{pos:t}}})}},"drawing/chart/axes/enabled":{parent:"drawing/chart/valid",enable:function(t){return t.isAxesEnabled()}},"drawing/chart/title/model":{parent:"drawing/chart/valid",get:function(t){return t?t.getTitleModel(null):null}},"drawing/chart/title/attributes":{parent:["drawing/chart/title/model","drawing/chart/valid"],get:function(t){return t?t.getMergedAttributeSet(!0):null},set:function(t){return d(this.getParentValue(1),null,t)}},"drawing/chart/title/text":{parent:["drawing/chart/title/attributes","drawing/chart/valid"],get:function(t){return g(t)},set:function(t){return h(this.getParentValue(1),null,t)}},"drawing/chart/title/delete":{parent:["drawing/chart/title/text","drawing/chart/valid"],enable:function(){return this.getValue().length>0},set:function(){return h(this.getParentValue(1),null,"")}}}),["x","y"].forEach(function(t){function e(e){return e?e.getAxisForType(t):null}function a(e){return e?e.getAxisIdForType(t):null}function i(t){return{line:t?n.getStandardShape(x):n.getNoneShape()}}function u(t,n){var a=e(t);return o(t,r.SET_CHART_AXIS_ATTRIBUTES,{axis:a.axisId,axPos:a.axPos,crossAx:a.crossAx,attrs:n})}function l(t,e){return o(t,r.SET_CHART_GRIDLINE_ATTRIBUTES,{axis:a(t),attrs:e})}var s="drawing/chart/axis/"+t+"/",c={};c[s+"model"]={parent:["drawing/chart/valid","drawing/chart/axes/enabled"],get:function(t){return t?t.getAxisModel(a(t)):null}},c[s+"attributes"]={parent:[s+"model","drawing/chart/valid"],get:function(t){return t?t.getMergedAttributeSet(!0):null},set:function(t){return u(this.getParentValue(1),t)}},c[s+"labels/visible"]={parent:[s+"attributes","drawing/chart/valid"],get:function(t){return _.isObject(t)&&!0===t.axis.label&&this.areParentsEnabled()},set:function(t){return u(this.getParentValue(1),{axis:{label:t}})}},c[s+"line/visible"]={parent:[s+"attributes","drawing/chart/valid"],get:function(t){return _.isObject(t)&&"none"!==t.line.type},set:function(t){return u(this.getParentValue(1),i(t))}},c[s+"grid/model"]={parent:s+"model",get:function(t){return t?t.getGrid():null}},c[s+"grid/attributes"]={parent:[s+"grid/model","drawing/chart/valid"],get:function(t){return t?t.getMergedAttributeSet(!0):null},set:function(t){return l(this.getParentValue(1),t)}},c[s+"grid/visible"]={parent:[s+"grid/attributes","drawing/chart/valid"],get:function(t){return _.isObject(t)&&"none"!==t.line.type},set:function(t){return l(this.getParentValue(1),i(t))}},c[s+"title/model"]={parent:s+"model",get:function(t){return t?t.getTitle():null}},c[s+"title/attributes"]={parent:[s+"title/model","drawing/chart/valid"],get:function(t){return t?t.getMergedAttributeSet(!0):null},set:function(t){var e=this.getParentValue(1);return d(e,a(e),t)}},c[s+"title/text"]={parent:[s+"title/attributes","drawing/chart/valid"],get:function(t){return g(t)},set:function(t){var e=this.getParentValue(1);return h(e,a(e),t)}},c[s+"title/delete"]={parent:[s+"title/text","drawing/chart/valid"],enable:function(){return this.getValue().length>0},set:function(){var t=this.getParentValue(1);return h(t,a(t),"")}},this.registerDefinitions(c)},this),this.registerDestructor(function(){T=v=x=i=null})}});