define("io.ox/office/spreadsheet/model/formula/interpret/formulacompiler",["io.ox/office/tk/utils","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,n,o){"use strict";function s(e,t){return _.isObject(e)&&e.isType("op")&&e.getValue()in f[t]}function i(e,t,r){this.token=e,this.operands=t||null,this.descriptor=r||null,this.recalc=null,this.relColRef=!1,this.relRowRef=!1,this.signature=null,this.error=null,this._initialize()}var a=r.ErrorCode,c=n.FormulaError,u=o.LiteralToken,l=o.OperatorToken,p=o.SheetRefToken,f={cmp:e.makeSet(["eq","ne","lt","le","gt","ge"]),con:e.makeSet(["con"]),upre:e.makeSet(["add","sub"]),upost:e.makeSet(["upct"]),add:e.makeSet(["add","sub"]),mul:e.makeSet(["mul","div"]),pow:e.makeSet(["pow"]),list:e.makeSet(["list"]),isect:e.makeSet(["isect"]),range:e.makeSet(["range"])};return i.prototype._ensure=function(e,t,r){return e||(this.error=new c(t,r)),!!e},i.prototype._initialize=function(){switch(this.token.getType()){case"ref":return this.relColRef=this.token.hasRelCol(),void(this.relRowRef=this.token.hasRelRow());case"table":return void(this.relRowRef="ROW"===this.token.getRegionKey())}if(this.descriptor){this.recalc=this.descriptor.recalc;var t=this.operands?this.operands.length:0;this.relColRef=!!this.descriptor.relColRef&&this.descriptor.relColRef(t),this.relRowRef=!!this.descriptor.relRowRef&&this.descriptor.relRowRef(t)}if(this.operands&&(this.recalc=this.operands.reduce(function(e,t){return n.getRecalcMode(e,t.recalc)},this.recalc),this.relColRef=this.relColRef||this.operands.some(function(e){return e.relColRef}),this.relRowRef=this.relRowRef||this.operands.some(function(e){return e.relRowRef})),this.operands&&this.descriptor){var r=this.descriptor.minParams,o=0,s=0;"maxParams"in this.descriptor?(o=this.descriptor.maxParams,s=1):(s="repeatParams"in this.descriptor?this.descriptor.repeatParams:1,o=r+e.roundDown(n.MAX_PARAM_COUNT-r,s));var i=this.operands.length;if(this._ensure(r<=i,"not enough parameters","missing")&&this._ensure(i<=o,"too many parameters","unexpected")&&this._ensure((i-r)%s==0,"not enough parameters","missing")){var a=this.descriptor.signature;(0===this.operands.length||a.length>0)&&(this.signature=_.times(this.operands.length,function(e){return a.length<=e&&(e=a.length-s+(e-a.length)%s),a[e]}))}}},i.prototype.isOperator=function(){return!!this.operands},i.prototype.toString=function(){return this.token+(this.isOperator()?":"+this.operands.length:"")},t.extend({constructor:function(e){var r=e.getFormulaResource().getOperatorCollection(),o=e.getFormulaResource().getFunctionCollection();t.call(this,e),this.compileTokens=n.profileMethod("FormulaCompiler.compileTokens()",function(e){function t(){return e[A]||null}function f(){var e=t();return e&&(A+=1),e}function h(){for(var e=f();e&&e.isType("ws");)e=f();return e}function d(){var e=h();if(e)return e;throw new c("unexpected end of formula","missing")}function m(e,t){if(M.length<t)throw new c("invalid operand stack size","missing");var n=t>0?M.splice(-t):[],s=e.isType("op")?r.get(e.getValue()):e.isType("func")?o.get(e.getValue()):null;M.push(new i(e,n,s)),s&&!s.resolve&&e.isType("func")&&(z[s.key]=!0)}function g(e){M.push(new i(e))}function w(e,t,r){var n=e(h());return m(t,r),n}function R(e,t){var r=E;return E=t,e=k(e),E=r,e}function k(e){for(e=x(e);s(e,"cmp");)e=w(x,e,2);return e}function x(e){for(e=v(e);s(e,"con");)e=w(v,e,2);return e}function v(e){for(e=y(e);s(e,"add");)e=w(y,e,2);return e}function y(e){for(e=T(e);s(e,"mul");)e=w(T,e,2);return e}function T(e){for(e=C(e);s(e,"pow");)e=w(C,e,2);return e}function C(e){if(s(e,"upre")){switch(e.getValue()){case"add":e=new l("uplus");break;case"sub":e=new l("uminus")}e=w(C,e,1)}else e=b(e);for(;s(e,"upost");)m(e,1),e=h();return e}function b(e){for(e=S(e);e&&(s(e,"list")||!E&&e.isType("sep"));)e.isType("sep")&&(e=new l("list")),e=w(S,e,2);return e}function S(e){for(e=_(e);s(e,"isect");)e=w(_,e,2);return e}function _(e){for(e=O(e);s(e,"range");)e=w(O,e,2);return e}function O(e){if(!e)throw new c("unexpected end of formula","missing");if(e instanceof p&&e.hasSheetError())throw new c("invalid sheet name","unexpected");switch(e.getType()){case"lit":case"mat":case"ref":case"name":case"table":return g(e),h();case"open":return F();case"func":case"macro":return P(e)}throw new c("operand expected","unexpected")}function F(){var e=R(d());if(e){if(!e.isType("close"))throw new c("closing parenthesis expected","unexpected")}else V+=1;return h()}function P(e){for(var t=e,r="start",n=0;"end"!==r;)switch(r){case"start":if(!(e=d()).isType("open"))throw new c("opening parenthesis expected","unexpected");r="open";break;case"open":(e=h())||(V+=1),r=!e||e.isType("close")?"close":"param";break;case"param":if(n+=1,e||(V+=1),!e||e.matchesType(/^(sep|close)$/))g(new u(null));else if(e=R(e,!0)){if(!e.matchesType(/^(sep|close)$/))throw new c("parameter separator expected","unexpected")}else V+=1;r=e?e.getType():"close";break;case"sep":e=h(),r="param";break;case"close":m(t,n),r="end"}return h()}var A=0,E=!1,M=[],V=0,z={};try{n.logTokens("compiling",e);var j=R(d());if(0===M.length)throw new c("missing formula expression","missing");if(M.length>1)throw new c("invalid formula expression","unexpected");if(j||A<e.length)throw new c("unexpected garbage at end of formula","unexpected");n.withLogging(function(){var e=[];!function t(r){e.push(r),r.isOperator()&&r.operands.forEach(t)}(M[0]),n.logTokens("compiled",e)})}catch(e){if(e instanceof c)return n.warn("error: "+e.message+", index="+(A-1)),{root:new i(new u(a.NA)),error:e.type,missingClose:0,missingFuncs:null};throw e}return{root:M[0],error:null,missingClose:V,missingFuncs:z}}),this.registerDestructor(function(){e=r=o=null})}})});