define("io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter",["io.ox/office/tk/utils","io.ox/office/tk/object/baseobject","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/presetformattable","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/formulacontext"],function(e,r,t,n,a,o,i,s){"use strict";function l(){this._operands=[]}var u=n.ErrorCode,c=n.Address,f=n.Range,p=n.Range3DArray,d=o.Scalar,m=o.Matrix,g=o.Dimension,v=o.FormulaError;l.prototype.push=function(e){this._operands.push({operand:null,resolve:_.once(e)})},l.prototype.size=function(){return this._operands.length},l.prototype.get=function(e){var r=this._operands[e];return r&&r.operand||null},l.prototype.resolve=function(e){var r=this._operands[e];return r?r.operand=r.resolve():null};var h=r.extend({constructor:function(t,n,d){function h(e){var r=e.getRange3D(d);return r?new p(r):u.REF}function y(e,r,t){var n=e.resolveNameModel(O);if(!n)return u.NAME;var a={refSheet:O,refAddress:c.A1,targetAddress:M.getRefAddress(),recalcDirty:F};return t&&(a.matrixRange=f.createFromAddressAndSize(a.targetAddress,t.cols,t.rows)),"mat"!==r||t||(r="any"),n.getTokenArray().interpretFormula(r,a).value}function w(e){var r=e.getRange3D(D);return r?new p(r):u.REF}function R(e,r){if("ref"===r&&"ref"!==e&&"any"!==e)throw new v("expected reference token","reference")}function k(e,r){return!r&&e instanceof i?e:M.createOperand(e,r)}function x(e,r,t){var n=e.token,a=null,i=null;switch(o.log("> resolving operand token "+n+" with context type "+r),n.getType()){case"lit":a=(i=n.getValue())===u.REF?"ref":"val";break;case"mat":i=n.getMatrix(),a="mat";break;case"ref":i=h(n),a="ref";break;case"name":i=y(n,r,t),a="any";break;case"table":i=w(n),a="ref";break;default:o.throwInternal('InterpreterInstance.resolveOperandNode(): unknown token type: "'+n.getType()+'"')}return R(a,r),k(i)}function S(e,r){if("combine"===r){for(var t=A,n=0;t&&n<e.size();n+=1){var i=e.get(n),s=i&&i.getFormat()||A;t=o.combineParsedFormats(t,s)}return t}var l=null;switch(r){case"percent":l=a.getPercentId(!0);break;case"currency":l=I.getCurrencyCode({red:!0});break;case"fraction":l=a.getFractionId(!0);break;case"date":l=a.SYSTEM_DATE_ID;break;case"time":l=a.getTimeId(null,!0);break;case"datetime":l=a.SYSTEM_DATETIME_ID}return null===l?null:I.getParsedFormat(l)}function b(e,r,t,n,a){return M.checkEvalTime(),k(function(){try{M.setMatrixPosition(n,a);var i=t.map(function(e,t){return e?M.convertOperandToValue(e,r[t].typeSpec):null});return o.logTokens("  resolving with parameters",i),e.resolve.apply(M,i)}catch(e){if(e instanceof u)return e;throw e}}())}function E(e,r,t){if(e.error)throw e.error;var n=e.token;o.log("> processing operator "+n+" with "+e.operands.length+" parameters and context type "+r);var a=e.descriptor;if(!a)return k(u.NAME);if(R(a.type,r),!_.isFunction(a.resolve))return o.warn('InterpreterInstance.resolveOperatorNode(): unsupported operator or function "'+n+'"'),k(o.UNSUPPORTED_ERROR);if(t&&!m.isValidDim(t))return k(o.UNSUPPORTED_ERROR);var i=new l,s=e.signature;s.forEach(function(n,o){var s=n.baseType,l=n.matSpec,u=e.operands[o],c="val"===s&&"val"===a.type,f="force"===l?"mat":s;"mat"!==r||!c&&"pass"!==l&&"forward"!==l||(f="mat");var p="mat"===f&&(c||"forward"===l);i.push(T.bind(null,u,f,p?t:null))});var c=s.map(function(e,r){return"any:lazy"===e.typeSpec?null:i.resolve(r)});if(!t&&"val"===a.type){var f="mat"===r;if(f||s.every(function(e){return"val"===e.baseType})){try{c.forEach(function(e,r){if(e&&(f?"val"===s[r].baseType&&!e.isScalar():e.isMatrix())){var n=e.getDimension({errorCode:u.VALUE});t=g.boundary(t,n)}})}catch(e){if(e instanceof u)return k(e);throw e}if(t){if(!m.isValidDim(t))return k(o.UNSUPPORTED_ERROR);r="mat"}}}var p=o.takeTime(a.key,function(){try{M.pushOperandResolver(i,r,t);var e=b(a,s,c,0,0);if("mat"===a.type&&e.isScalar()&&(e=k(m.create(1,1,e.getRawValue()))),"any"===a.type||a.type===e.getType()||"ref"===a.type&&e.isScalar()&&e.getRawValue()instanceof u||"val"===a.type&&"mat"===r&&e.isMatrix()||o.throwInternal("InterpreterInstance.resolveOperatorNode(): "+a.key+": operator result type does not match operator return type"),t&&e.isScalar()){o.info("  expand scalar result to "+t+" matrix");var n=m.generate(t.rows,t.cols,function(r,t){if(0===r&&0===t)return e.getRawValue();var n=b(a,s,c,r,t);if(n.isScalar())return n.getRawValue();o.throwInternal("InterpreterInstance.resolveOperatorNode(): invalid matrix element type")});e=k(n)}return e}finally{M.popOperandResolver()}}),d=a.format&&"mat"!==r?S(i,a.format):null;return d?k(p,{format:d}):p}function T(e,r,t){var n=e.isOperator()?E(e,r,t):x(e,r,t);return o.log("< result of "+e+": "+n),n}var I=t.getNumberFormatter(),A=I.getStandardFormat(),O=e.getIntegerOption(d,"refSheet",null),D=e.getOption(d,"targetAddress",c.A1),F=e.getOption(d,"recalcDirty",!1),M=new s(t,d);r.call(this,t),this.getResult=function(e,r){var t=function(){try{return T(n,e,r)}catch(e){if(e instanceof u)return k(e);throw e}}();e="any"===e?t.getType():e;var a={value:function(){try{switch(e){case"val":return t.getScalar(null,null);case"mat":return t.getMatrix();case"ref":return t.getRanges();default:o.throwInternal('InterpreterInstance.getResult(): unknown context type: "'+e+'"')}}catch(e){if(e instanceof u)return e;throw e}}()},i=t.getFormat();i&&!i.isStandard()&&(a.format=i);var s=t.getURL();return null!==s&&(a.url=s),a},this.registerDestructor(function(){t=n=d=I=M=null})}});return t.extend({constructor:function(r){function n(e,r,t,n){var a="mat"===e?m.create(1,1,n):n;return o.withLogging(function(){o.info("result: type="+r+" code="+t+" value="+d.toString(a))}),{type:r,code:t,value:a}}var a={withCase:"odf"===r.getApp().getFileFormat(),nullMode:"convert"};t.call(this,r),this.equalScalars=function(e,r){return d.equal(e,r,a)},this.compareScalars=function(e,r){return d.compare(e,r,a)},this.createWarnResult=function(e,r){return n(e,"warn",r.key,"value"in r?r.value:r)},this.createErrorResult=function(e,r){return n(e,"error",r,u.NA)},this.interpretTokens=o.profileMethod("FormulaInterpreter.interpretTokens()",function(t,n,a){o.log("contextType="+t);var i=new h(r,n,a);try{var s="mat"===t?e.getOption(a,"matrixRange",null):null,l=s?g.createFromRange(s):null,c=i.getResult(t,l);return o.isInternalError(c.value)?this.createWarnResult(t,c.value):(c.type="valid",o.withLogging(function(){o.info("result: type=valid value="+d.toString(c.value)+" format="+c.format+" url="+c.url)}),c)}catch(e){if(e instanceof u)return this.createWarnResult(t,e);if(e instanceof v)return o.warn("  error: "+e.message),this.createErrorResult(t,e.type);throw e}finally{i.destroy()}}),this.registerDestructor(function(){r=null})}})});