define("io.ox/office/spreadsheet/model/formula/parser/expressionparser",["io.ox/office/tk/utils","io.ox/office/tk/utils/class","io.ox/office/tk/locale/parser","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,n,a,s){"use strict";function c(e,t){this.token=e,this.index=-1,this.text=t,this.start=0,this.end=0}var i=n.Address,o=a.Matrix,R=a.SheetRef;c.prototype.toString=function(){return this.token.toString()};var h=t.extendable(function(e,t){this.docModel=e,this.grammar=t,this.RE=t.RE,this.refGrammar=t.refGrammar});h.prototype._initOptions=function(t){this.refAddress=e.getOption(t,"refAddress",i.A1),this.refSheet=e.getIntegerOption(t,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.wrapReferences=e.getBooleanOption(t,"wrapReferences",!1),this.autoCorrect=e.getBooleanOption(t,"autoCorrect",!1),this.extendSheet=e.getBooleanOption(t,"extendSheet",!1),this.unqualifiedTables=e.getBooleanOption(t,"unqualifiedTables",!1)},h.prototype._parseNextToken=function(e){var t=this.RE,n=null,a=null;return(n=t.STRING_LIT.exec(e))?this.createLiteralToken(n[0].slice(1,n[0].length-1).replace(/""/g,'"'),n[0]):(n=t.BOOLEAN_LIT.exec(e))?this.createLiteralToken(this.grammar.getBooleanValue(n[0]),n[0]):(n=t.ERROR_LIT.exec(e))?this.createLiteralToken(this.grammar.getErrorCode(n[0]),n[0]):(n=t.FRACTION_LIT.exec(e))?this.createLiteralToken(parseInt(n[1],10)+parseInt(n[2],10)/parseInt(n[3],10),n[0]):(n=t.WHITESPACE.exec(e))?this.createFixedToken("ws",n[0]):(n=t.SEPARATOR.exec(e))?this.createToken(new s.SeparatorToken,n[0]):(n=t.OPERATOR.exec(e))?this.createToken(new s.OperatorToken(this.grammar.getOperatorKey(n[0])),n[0]):(n=t.OPEN.exec(e))?this.createToken(new s.ParenthesisToken(!0),n[0]):(n=t.CLOSE.exec(e))?this.createToken(new s.ParenthesisToken(!1),n[0]):(n=t.MATRIX_OPEN.exec(e))?this._parseMatrixLit(e):(a=this.parseNextRefToken(e))?a:(n=r.parseLeadingNumber(e,{dec:this.grammar.DEC}))?this.createLiteralToken(n.number,n.text):(a=this.parseNextNameToken(e))?a:void 0},h.prototype._parseMatrixLit=function(e){function t(){return R.every(function(e,t){return 0===t||e.length===R[t-1].length})}for(var n=e,a="start",c=this.RE,i=null,R=[],h=null;"end"!==a;){switch(a){case"start":(i=c.MATRIX_OPEN.exec(e))&&(R.push(h=[]),a="open");break;case"open":case"sep":(i=c.WHITESPACE.exec(e))||((i=c.FRACTION_LIT.exec(e))?(h.push(parseInt(i[1],10)+parseInt(i[2],10)/parseInt(i[3],10)),a="lit"):(i=r.parseLeadingNumber(e,{dec:this.grammar.DEC,sign:!0}))?(h.push(i.number),i=[i.text],a="lit"):(i=c.STRING_LIT.exec(e))?(h.push(i[0].slice(1,i[0].length-1).replace(/""/g,'"')),a="lit"):(i=c.BOOLEAN_LIT.exec(e))?(h.push(this.grammar.getBooleanValue(i[0])),a="lit"):(i=c.ERROR_LIT.exec(e))&&(h.push(this.grammar.getErrorCode(i[0])),a="lit"));break;case"lit":0===e.length?(i=this.autoCorrect&&t()?[""]:null,a="end"):(i=c.WHITESPACE.exec(e))||((i=c.MATRIX_ROW_SEPARATOR.exec(e))?(R.push(h=[]),a="sep"):(i=c.MATRIX_COL_SEPARATOR.exec(e))?a="sep":(i=c.MATRIX_CLOSE.exec(e))&&(t()||(i=null),a="end"))}if(!i)return null;e=e.substr(i[0].length)}var l=n.substr(0,n.length-e.length);return this.createToken(new s.MatrixToken(new o(R)),l)},h.prototype.createToken=function(e,t){return new c(e,t)},h.prototype.createFixedToken=function(e,t){return this.createToken(new s.FixedToken(e,t),t)},h.prototype.createLiteralToken=function(e,t){return this.createToken(new s.LiteralToken(e),t)},h.prototype.createReferenceToken=function(e,t,r){return!e&&this.extendSheet&&this.refSheetModel&&(e={r1:new R(this.refSheet,!0),r2:null}),this.createToken(new s.ReferenceToken(this.docModel,t?t.r1:null,t?t.r2:null,e?e.r1:null,e?e.r2:null),r)},h.prototype.createNameToken=function(t,r,n,a){!t&&this.extendSheet&&this.refSheetModel&&this.refSheetModel.getNameCollection().hasName(r)&&(t=new R(this.refSheet,!0));var c=!t&&/^\[0\]!/.test(n),i=new s.NameToken(this.docModel,r,t,c?0:null);return(e.getBooleanOption(a,"resolveTable",!1)?i.resolveTableModel():null)&&(i=new s.TableToken(this.docModel,r)),this.createToken(i,n)},h.prototype.createFunctionToken=function(e,t,r){var n=e?null:this.grammar.getFunctionKey(t);return this.createToken(n?new s.FunctionToken(n):new s.MacroToken(this.docModel,t,e),r)},h.prototype.createSheetRef=function(e,t){return this.refGrammar.createSheetRef(this.docModel,e,t)},h.prototype.createSheetRefs=function(e,t,r){return this.refGrammar.createSheetRefs(this.docModel,e,t,r)},h.prototype.createCellRangeRefs=function(e,t,r){return this.refGrammar.createCellRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},h.prototype.createColRangeRefs=function(e,t,r){return this.refGrammar.createColRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},h.prototype.createRowRangeRefs=function(e,t,r){return this.refGrammar.createRowRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},h.prototype.parseNextRefToken=function(){return e.error("ExpressionParserBase.parseNextRefToken(): missing implementation"),null},h.prototype.parseNextNameToken=function(){return e.error("ExpressionParserBase.parseNextNameToken(): missing implementation"),null},h.prototype.parseFormula=function(t,r){this._initOptions(r);for(var n=[];t.length>0;){var c=this._parseNextToken(t)||this.createFixedToken("bad",t);n.push(c),t=t.substr(c.text.length)}a.logTokens("tokenize",n);var i=this.grammar.isSpaceIntersection();return e.iterateArray(n,function(e,t){var r=e.token,a=n[t-1],c=n[t+1];if(r.isType("op")&&"sub"===r.getValue()&&c&&c.token.isType("lit")){var o=c.token.getValue();if("number"==typeof o&&o>0){var R=a&&a.token.isType("ws")?n[t-2]:a;R&&!R.token.matchesType(/^(op|sep|open)$/)||(e.token=new s.LiteralToken(-o),e.text+=c.text,n.splice(t+1,1))}}if(i&&r.isType("ws")){var h=h=e.text.indexOf(" ");if(h>=0&&a&&a.token.matchesType(/^(ref|name|close)$/)&&c&&c.token.matchesType(/^(ref|name|open|func)$/)){if(h+1<e.text.length){var l=e.text.slice(h+1);n.splice(t+1,0,this.createFixedToken("ws",l))}n.splice(t+1,0,this.createToken(new s.OperatorToken("isect")," ")),h>0?(r.setValue(e.text.slice(0,h)),e.text=r.getValue()):n.splice(t,1)}}},{reverse:!0,context:this}),a.logTokens("postprocess",n),n.forEach(function(e,t){e.index=t,e.start=0===t?0:n[t-1].end,e.end=e.start+e.text.length}),n},h.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var l=h.extend(function(e,t){h.call(this,e,t)});l.prototype._parseTableRef=function(e,t){function r(){x[f.getTableRegionKey(E[1])]=!0,T="ref"}function n(e,t){"col1Name"in p?(E=null,T="end"):(p.col1Name=f.decodeTableColumn(e),p.col2Name=t?f.decodeTableColumn(t):null,T="ref")}function a(){n(E[1],E[2])}function c(e){e&&E[1]&&(p.openWs=!0),n(E[2]||E[3],E[4]||E[5])}function i(){E[1]&&(p.closeWs=!0),u||0!==E[2].length||(E=null),T="end"}var o=this.RE,R=e;t&&(e=e.substr(t.text.length));var h=o.TABLE_OPEN.test(e),l=t?t.token.resolveTableModel():null;if(t&&h&&!l)return null;if(t&&!h&&l)return this.createToken(new s.TableToken(this.docModel,t.token.getValue()),t.text);if(!h)return t;if(!t&&this.grammar.UI&&this.unqualifiedTables&&this.refSheetModel&&(l=this.refSheetModel.getTableCollection().findTable(this.refAddress)),!l)return null;for(var f=this.grammar,u=this.autoCorrect,T="start",E=null,p={},x={};"end"!==T;){switch(T){case"start":(E=o.TABLE_OPEN.exec(e))&&(E[1]&&(p.openWs=!0),T="open");break;case"open":(E=o.TABLE_CLOSE.exec(e))?i():(E=o.TABLE_SINGLE_REGION_NAME.exec(e))?r():(E=o.TABLE_SINGLE_COLUMN_NAME.exec(e))?a():(E=o.TABLE_REGION_REF.exec(e))?r():!this.grammar.UI&&(E=o.TABLE_COLUMN_RANGE_REF.exec(e))?a():!this.grammar.UI&&(E=o.TABLE_COLUMN_REF.exec(e))?a():this.grammar.UI&&(E=o.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?c(!0):this.grammar.UI&&(E=o.TABLE_MIXED_COLUMN_REF.exec(e))?c(!0):this.grammar.UI&&(E=o.TABLE_THISROW_REF.exec(e))&&(x.ROW=!0,T="row");break;case"ref":(E=o.TABLE_CLOSE.exec(e))?i():(E=o.TABLE_SEPARATOR.exec(e))&&(E[2]&&(p.sepWs=!0),T="sep");break;case"sep":(E=o.TABLE_REGION_REF.exec(e))?r():!this.grammar.UI&&(E=o.TABLE_COLUMN_RANGE_REF.exec(e))?a():!this.grammar.UI&&(E=o.TABLE_COLUMN_REF.exec(e))?a():this.grammar.UI&&(E=o.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?c():this.grammar.UI&&(E=o.TABLE_MIXED_COLUMN_REF.exec(e))&&c();break;case"row":(E=o.TABLE_CLOSE.exec(e))?(i(),p.closeWs&&(E=null)):(E=o.WHITESPACE.exec(e))||((E=o.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?c():(E=o.TABLE_MIXED_COLUMN_REF.exec(e))&&c())}if(!E)return null;e=e.substr(E[0].length)}switch((x=_.keys(x)).length){case 0:break;case 1:p.regionKey=x[0];break;case 2:if("HEADERS,DATA"===(x=x.join(","))||"DATA,HEADERS"===x)p.regionKey="HEADERS,DATA";else{if("DATA,TOTALS"!==x&&"TOTALS,DATA"!==x)return null;p.regionKey="DATA,TOTALS"}break;default:return null}var k=R.substr(0,R.length-e.length);return this.createToken(new s.TableToken(this.docModel,l.getName(),p),k)},l.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,n=null;return(r=t.RANGE_REF.exec(e))&&(n=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(null,n,r[0]):(r=t.RANGE_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,4,8))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.RANGE_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.CELL_REF.exec(e))&&(n=this.createCellRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.CELL_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.CELL_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.COLS_REF.exec(e))&&(n=this.createColRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.COLS_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,4,6))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COLS_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.COL_REF.exec(e))&&(n=this.createColRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.COL_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COL_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ROWS_REF.exec(e))&&(n=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.ROWS_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,4,6))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROWS_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ROW_REF.exec(e))&&(n=this.createRowRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.ROW_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROW_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),null,r[0]):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1,!0),null,r[0]):void 0},l.prototype.parseNextNameToken=function(e){var t=this.RE,r=this.refGrammar.RE,n=null;return(n=r.FUNCTION_REF.exec(e))?this.createFunctionToken(null,n[1],n[0]):(n=r.FUNCTION_3D_REF.exec(e))?this.createFunctionToken(this.createSheetRef(n,1),n[4],n[0]):(n=r.NAME_3D_REF.exec(e))?this._parseTableRef(e,this.createNameToken(this.createSheetRef(n,1),n[4],n[0])):(n=r.NAME_REF.exec(e))?this._parseTableRef(e,this.createNameToken(null,n[1],n[0])):this.grammar.UI&&(n=t.TABLE_OPEN.exec(e))?this._parseTableRef(e,null):void 0};var f=h.extend(function(e,t){h.call(this,e,t)});f.prototype.createSheetRangeData=function(e,t){return{r1:R.create(this.docModel,e[t+1],e[t+2],null,!!e[t]),r2:R.create(this.docModel,e[t+4],e[t+5],null,!!e[t+3])}},f.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,n=null;return(r=t.RANGE_REF.exec(e))&&(n=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(null,n,r[0]):(r=t.RANGE_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.RANGE_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,7,11))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.CELL_REF.exec(e))&&(n=this.createCellRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.CELL_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.CELL_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.COLS_REF.exec(e))&&(n=this.createColRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.COLS_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COLS_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,7,9))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.COL_REF.exec(e))&&(n=this.createColRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.COL_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COL_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ROWS_REF.exec(e))&&(n=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.ROWS_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROWS_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,7,9))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ROW_REF.exec(e))&&(n=this.createRowRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.ROW_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROW_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),null,r[0]):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRangeData(r,1),null,r[0]):void 0},f.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(null,r[1],r[0]):(r=t.NAME_REF.exec(e))?this.createNameToken(null,r[1],r[0],{resolveTable:!0}):void 0};var u=h.extend(function(e,t){h.call(this,e,t)});u.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.CELL_REF.exec(e))?this.createReferenceToken(null,this.createCellRangeRefs(r,1),r[0]):(r=t.CELL_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),this.createCellRangeRefs(r,5),r[0]):(r=t.RANGE_REF.exec(e))?this.createReferenceToken(null,this.createCellRangeRefs(r,1,5),r[0]):(r=t.RANGE_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),this.createCellRangeRefs(r,5,9),r[0]):(r=t.RANGE_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1,9),this.createCellRangeRefs(r,5,13),r[0]):void 0},u.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(null,r[1],r[0]):(r=t.NAME_REF.exec(e))?this.createNameToken(null,r[1],r[0],{resolveTable:!0}):void 0};var T={};return T.create=function(t,r){var n=t.getFormulaGrammar(r);switch(n.REF_SYNTAX){case"ooxml":return new l(t,n);case"odfui":return new f(t,n);case"of":return new u(t,n)}e.error('ExpressionParser.create(): invalid reference syntax: "'+n.REF_SYNTAX+'"')},T});