define("io.ox/office/spreadsheet/model/formula/parser/rangelistparser",["io.ox/office/tk/utils","io.ox/office/tk/utils/class","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(e,t,r,n){"use strict";var i=r.Address,s=r.Range,a=r.RangeArray,o=n.SheetRef,l=t.extendable(function(e,t){this.docModel=e,this.MAXCOL=e.getMaxCol(),this.MAXROW=e.getMaxRow(),this.grammar=t,this.refGrammar=t.refGrammar,this.addrConfig=this.refGrammar.addrConfig,this.RE=this.refGrammar.RE});l.prototype._initOptions=function(t){this.refSheet=e.getIntegerOption(t,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.extSep=e.getBooleanOption(t,"extSep",!1),this.skipSheets=e.getBooleanOption(t,"skipSheets",!1)},l.prototype._parseSeparator=function(e){var t=this.RE,r=null;return(r=t.RL_SEP_WS.exec(e))?{sep:" ",text:r[0]}:this.extSep&&(r=t.RL_SEP_OTHER.exec(e))?{sep:r[0],text:r[0]}:null},l.prototype.getAddress=function(e,t){return this.addrConfig.getAddress(e,t,this.MAXCOL,this.MAXROW)},l.prototype.getRange=function(e,t,r){var n=this.getAddress(e,t),i="number"==typeof r?this.getAddress(e,r):n;return n&&i?s.createFromAddresses(n,i):null},l.prototype.getColRange=function(e,t,r){var n=this.addrConfig.getCol(e,t,this.MAXCOL),i="number"==typeof r?this.addrConfig.getCol(e,r,this.MAXCOL):n;return n>=0&&i>=0?s.create(n,0,i,this.MAXROW):null},l.prototype.getRowRange=function(e,t,r){var n=this.addrConfig.getRow(e,t,this.MAXROW),i="number"==typeof r?this.addrConfig.getRow(e,r,this.MAXROW):n;return n>=0&&i>=0?s.create(0,n,this.MAXCOL,i):null},l.prototype.createRangeDesc=function(e,t,r){if(!t)return null;if(e){if(e.r1.sheet!==this.refSheet)return null;if(e.r2&&e.r2.sheet!==this.refSheet)return null}return{range:t,text:r}},l.prototype.implParseRange=function(){return e.error("RangeListParserBase.implParseRange(): missing implementation"),null},l.prototype.implFormatRange=function(){return e.error("RangeListParserBase.implFormatRange(): missing implementation"),null},l.prototype.parseRange=function(e,t){this._initOptions(t);var r=this.implParseRange(e);return r&&e.length===r.text.length?r.range:null},l.prototype.formatRange=function(t,r){var n=e.getStringOption(r,"sheetName",null);return this.implFormatRange(t,n)},l.prototype.parseRangeList=function(e,t){this._initOptions(t);for(var r="start",n=new a,i=null;"end"!==r;)switch(r){case"start":r="range";break;case"range":var s=this.implParseRange(e);if(!s)return null;n.push(s.range),e=e.substr(s.text.length),r="sep";break;case"sep":if(0===e.length){r="end";break}var o=this._parseSeparator(e);if(!o||null!==i&&i!==o.sep)return null;i=o.sep,e=e.substr(o.text.length),r="range"}return n},l.prototype.formatRangeList=function(t,r){var n=e.getStringOption(r,"sep"," "),i=e.getStringOption(r,"sheetName",null);return a.get(t).map(function(e){return this.implFormatRange(e,i)},this).join(n)},l.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var g=l.extend(function(e,t){l.call(this,e,t)});g.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0]);if(r=t.RL_COLS_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3,4),r[0]);if(r=t.RL_COL_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3),r[0]);if(r=t.RL_ROWS_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3,4),r[0]);if(r=t.RL_ROW_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):(r=t.RL_COLS_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1,2),r[0]):(r=t.RL_COL_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1),r[0]):(r=t.RL_ROWS_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1,2),r[0]):(r=t.RL_ROW_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1),r[0]):void 0},g.prototype.implFormatRange=function(e,t){var r=null,n=null;e.single()?r=e.start.toString():this.docModel.isRowRange(e)?(r=i.stringifyRow(e.start[1]),n=i.stringifyRow(e.end[1])):this.docModel.isColRange(e)?(r=i.stringifyCol(e.start[0]),n=i.stringifyCol(e.end[0])):(r=e.start.toString(),n=e.end.toString());var s=t?new o(t,!1):null;return this.grammar.formatGenericRange(this.docModel,s,null,r,n)};var R=l.extend(function(e,t){l.call(this,e,t)});R.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_CUBE_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,7),r[0]);if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):void 0},R.prototype.implFormatRange=function(e,t){var r=e.start.toString(),n=e.single()?null:e.end.toString(),i=t?new o(t,!1):null,s=t&&n?i:null;return this.grammar.formatGenericRange(this.docModel,i,s,r,n)};var h={};return h.create=function(t,r){var n=t.getFormulaGrammar(r);switch(n.REF_SYNTAX){case"ooxml":case"odfui":return new g(t,n);case"of":return new R(t,n)}e.error('RangeListParser.create(): invalid reference syntax: "'+n.REF_SYNTAX+'"')},h});