define("io.ox/office/spreadsheet/model/formula/parser/tokens",["io.ox/office/tk/utils","io.ox/office/tk/utils/class","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(e,t,s,l){"use strict";var r=s.ErrorCode,o=s.Interval,n=s.Address,i=s.Range,a=s.Range3D,h=s.RangeArray,f=s.IntervalArray,u=s.Range3DArray,c=s.MoveDescriptor,R=l.Scalar,p=l.CellRef,g=l.SheetRef,d=t.extendable(function(e){this._type=e});d.prototype.getType=function(){return this._type},d.prototype.isType=function(e){return e===this._type},d.prototype.matchesType=function(e){return e.test(this._type)},d.prototype.getText=function(){return e.error("BaseToken.getText(): missing implementation"),""},d.prototype.debugText=function(){return e.error("BaseToken.debugText(): missing implementation"),""},d.prototype.toString=function(){var e=this.debugText();return this._type+(e?"["+e+"]":"")},d.prototype.resolveDeletedSheet=function(){return null},d.prototype.resolveRenamedSheet=function(){return null},d.prototype.resolveRelabeledName=function(){return null},d.prototype.resolveMovedCells=function(){return null},d.prototype.resolveCutPasteCells=function(){return null};var v=d.extend(function(e,t){d.call(this,e),this._text=t});v.prototype.getValue=function(){return this._text},v.prototype.setValue=function(e){return this._text!==e&&(this._text=e,!0)},v.prototype.appendValue=function(e){return 0!==e.length&&(this._text+=e,!0)},v.prototype.getText=function(){return this._text},v.prototype.debugText=function(){return this._text};var m=d.extend(function(e){d.call(this,"op"),this._value=e});m.prototype.getValue=function(){return this._value},m.prototype.getText=function(e){return e.getOperatorName(this._value)||"?"},m.prototype.debugText=function(){return this._value};var y=d.extend(function(){d.call(this,"sep")});y.prototype.getText=function(e){return e.SEP},y.prototype.debugText=_.constant("");var b=v.extend(function(e){v.call(this,e?"open":"close",e?"(":")")});b.prototype.debugText=_.constant("");var x=d.extend(function(e){d.call(this,"lit"),this._value=e});x.prototype.getValue=function(){return this._value},x.prototype.setValue=function(e){return this._value!==e&&(this._value=e,!0)},x.prototype.getText=function(e){return e.formatScalar(this._value)},x.prototype.debugText=function(){return R.toString(this._value)};var T=d.extend(function(e){d.call(this,"mat"),this._matrix=e});T.prototype.getMatrix=function(){return this._matrix},T.prototype.getText=function(e){var t=e.MAT_OPEN;return this._matrix.forEach(function(s,l,r){r>0?t+=e.MAT_COL:l>0&&(t+=e.MAT_ROW),t+=e.formatScalar(s)}),t+e.MAT_CLOSE},T.prototype.debugText=function(){return this._matrix.toString()};var M=d.extend(function(e){d.call(this,"func"),this._value=e});M.prototype.getValue=function(){return this._value},M.prototype.getText=function(e){return e.getFunctionName(this._value)||this._value.toUpperCase()},M.prototype.debugText=function(){return this._value};var N=d.extend(function(e,t,s,l,r){if(d.call(this,e),this._docModel=t,this._sheet1Ref=s,this._sheet2Ref=l,this._extDocRef=r,s&&s.valid()&&l&&l.valid()&&l.sheet<s.sheet){var o=l.abs;l.abs=s.abs,s.abs=o;var n=l.sheet;l.sheet=s.sheet,s.sheet=n}});N.prototype._isOwnSheetRef=function(e){return this.isOwnDoc()&&_.isObject(e)},N.prototype._resolveSheetRefs=function(t){return{s1:e.getOption(t,"sheet1Ref",this._sheet1Ref),s2:e.getOption(t,"sheet2Ref",this._sheet2Ref)}},N.prototype._resolveSheetInterval=function(t){if(!this.isOwnDoc())return null;var s=this._sheet1Ref?this._sheet1Ref.sheet:e.getIntegerOption(t,"refSheet",null),l=this._sheet2Ref?this._sheet2Ref.sheet:s;return"number"==typeof s&&s>=0&&"number"==typeof l&&l>=0?o.create(s,l):null},N.prototype.isOwnDoc=function(){return!this._extDocRef},N.prototype.hasSheetRef=function(){return!!this._sheet1Ref},N.prototype.hasSheetError=function(){return!!this._sheet1Ref&&!this._sheet1Ref.valid()||!!this._sheet2Ref&&!this._sheet2Ref.valid()},N.prototype.refreshSheets=function(){var e=this._isOwnSheetRef(this._sheet1Ref)&&this._sheet1Ref.refresh(this._docModel),t=this._isOwnSheetRef(this._sheet2Ref)&&this._sheet2Ref.refresh(this._docModel);return e||t},N.prototype.transformSheet=function(e,t){var s=this._isOwnSheetRef(this._sheet1Ref)&&this._sheet1Ref.transform(e,t),l=this._isOwnSheetRef(this._sheet2Ref)&&this._sheet2Ref.transform(e,t);return s||l},N.prototype.debugSheetPrefix=function(){var e=null===this._extDocRef?"":"["+this._extDocRef+"]";return this._sheet1Ref&&(e+=this._sheet1Ref.toString()),this._sheet1Ref&&this._sheet2Ref&&!this._sheet1Ref.equals(this._sheet2Ref)&&(e+=":"+this._sheet2Ref.toString()),e?e+"!":""},N.prototype.resolveDeletedSheet=function(e,t,s){if(!this.isOwnDoc())return null;var l=this._sheet1Ref?this._resolveSheetInterval({refSheet:s}):null;return l?l.single()?t===l.first?this.getText(e,{sheet1Ref:new g(-1,!0)}):null:t===l.first?this.getText(e,{sheet1Ref:new g(l.first+1,this._sheet1Ref.abs),sheet2Ref:new g(l.last,this._sheet2Ref.abs)}):t===l.last?this.getText(e,{sheet1Ref:new g(l.first,this._sheet1Ref.abs),sheet2Ref:new g(l.last-1,this._sheet2Ref.abs)}):null:null},N.prototype.resolveRenamedSheet=function(e,t,s){if(!this.isOwnDoc())return null;var l=this._sheet1Ref&&this._sheet1Ref.sheet===t?new g(s,this._sheet1Ref.abs):this._sheet1Ref,r=this._sheet2Ref&&this._sheet2Ref.sheet===t?new g(s,this._sheet2Ref.abs):this._sheet2Ref;return l!==this._sheet1Ref||r!==this._sheet2Ref?this.getText(e,{sheet1Ref:l,sheet2Ref:r}):null};var S=N.extend(function(e,t,s,l,r){if(N.call(this,"ref",e,l,r,null),this._cell1Ref=t,this._cell2Ref=s,t&&s&&s.col<t.col){var o=s.absCol;s.absCol=t.absCol,t.absCol=o;var n=s.col;s.col=t.col,t.col=n}if(this._cell1Ref&&this._cell2Ref&&this._cell2Ref.row<this._cell1Ref.row){var i=s.absRow;s.absRow=t.absRow,t.absRow=i;var a=s.row;s.row=t.row,t.row=a}});S.prototype._isSingleRelative=function(e){return!this._cell1Ref.isAbs(e)&&(!this._cell2Ref||!this._cell2Ref.isAbs(e)&&this._cell1Ref.getIndex(e)===this._cell2Ref.getIndex(e))},S.prototype._resolveCellRefs=function(t){var s=e.getOption(t,"refAddress",n.A1),l=e.getOption(t,"targetAddress",n.A1);if(s.equals(l))return{r1:this._cell1Ref,r2:this._cell2Ref};var r={r1:this._cell1Ref?this._cell1Ref.clone():null,r2:this._cell2Ref?this._cell2Ref.clone():null},o=e.getBooleanOption(t,"wrapReferences",!1);return r.r1&&!r.r1.relocate(this._docModel,s,l,o)&&(r.r1=null),r.r1&&r.r2&&!r.r2.relocate(this._docModel,s,l,o)&&(r.r1=r.r2=null),r},S.prototype.getRange3D=function(e){var t=this._resolveSheetInterval(e);if(!t)return null;var s=this._resolveCellRefs(e);if(!s.r1)return null;var l=s.r1.toAddress(),r=s.r2?s.r2.toAddress():null;return r?a.createFromAddresses(l,r,t.first,t.last):a.createFromAddress(l,t.first,t.last)},S.prototype.getExpandedRanges=function(t,s,l){function r(e,s,l,r){var o=e.getIndex(l);return e.isAbs(l)?o:o+(r?s.start:s.end).get(l)-t.get(l)}function n(e,t){var s=r(this._cell1Ref,e,t,!0);this._cell2Ref&&(s=Math.min(s,r(this._cell2Ref,e,t,!0)));var l=r(this._cell1Ref,e,t,!1);this._cell2Ref&&(l=Math.max(l,r(this._cell2Ref,e,t,!1)));var n=this._docModel.getMaxIndex(t);if(a){s<0?(s+=n+1,l+=n+1):s>n&&(s-=n+1,l-=n+1);var i=new f;return l<=n?i.push(new o(s,l)):this._isSingleRelative(t)?(i.push(new o(0,l-n-1)),i.push(new o(s,n))):i.push(new o(0,n)),i}return s=Math.max(s,0),l=Math.min(l,n),s<=l?new f(new o(s,l)):null}if(!this._cell1Ref)return null;var i=this._resolveSheetInterval(l);if(!i)return null;var a=e.getBooleanOption(l,"wrapReferences",!1);return u.map(s,function(e){var t=n.call(this,e,!0),s=t?n.call(this,e,!1):null;return s?u.createFromIntervals(t,s,i.first,i.last):null},this)},S.prototype.hasRelCol=function(){return!!this._cell1Ref&&(!this._cell1Ref.absCol||!!this._cell2Ref&&!this._cell2Ref.absCol)},S.prototype.hasRelRow=function(){return!!this._cell1Ref&&(!this._cell1Ref.absRow||!!this._cell2Ref&&!this._cell2Ref.absRow)},S.prototype.setRange=function(e){var t=!1;return this._cell1Ref||(this._cell1Ref=new p(0,0,!0,!0),t=!0),this._cell2Ref||e.single()||(this._cell2Ref=this._cell1Ref.clone(),t=!0),this._cell1Ref.col!==e.start[0]&&(this._cell1Ref.col=e.start[0],t=!0),this._cell1Ref.row!==e.start[1]&&(this._cell1Ref.row=e.start[1],t=!0),this._cell2Ref&&(this._cell2Ref.col!==e.end[0]&&(this._cell2Ref.col=e.end[0],t=!0),this._cell2Ref.row!==e.end[1]&&(this._cell2Ref.row=e.end[1],t=!0),this._cell1Ref.equals(this._cell2Ref)&&(this._cell2Ref=null,t=!0)),t},S.prototype.relocateRange=function(e,t,s){return!(!this._cell1Ref||e.equals(t))&&(this._cell1Ref.relocate(this._docModel,e,t,s)?(this._cell2Ref&&!this._cell2Ref.relocate(this._docModel,e,t,s)&&(this._cell1Ref=this._cell2Ref=null),!0):(this._cell1Ref=this._cell2Ref=null,!0))},S.prototype.getText=function(t,s){var l=this._resolveSheetRefs(s),r=this._resolveCellRefs(s),o=e.getOption(s,"targetAddress",n.A1);return t.formatReference(this._docModel,o,l.s1,l.s2,r.r1,r.r2)},S.prototype.debugText=function(){var e=this.debugSheetPrefix();return e+=this._cell1Ref?this._cell1Ref:r.REF,e+=this._cell1Ref&&this._cell2Ref?":"+this._cell2Ref:""},S.prototype.resolveMovedCells=function(t,s,l,r){var o=this.getRange3D(r);if(!o||!o.isSheet(s))return null;var a=e.getBooleanOption(r,"freezeRelRefs",!1),h=o.toRange(),f=h.clone();if(l.every(function(e){if(a){var t=!this._cell1Ref.isAbs(e.columns),s=!this._cell2Ref||!this._cell2Ref.isAbs(e.columns);if(t&&s)return f;if(t){var l=e.transformAddress(f.end);return f=l?i.createFromAddresses(f.start,l):null}if(s&&this._cell2Ref){var r=e.transformAddress(f.start);return f=r?i.createFromAddresses(r,f.end):null}}return f=e.transformRange(f)},this),f&&f.equals(h))return null;var u=f&&p.create(f.start,this._cell1Ref.absCol,this._cell1Ref.absRow),c=f&&this._cell2Ref&&p.create(f.end,this._cell2Ref.absCol,this._cell2Ref.absRow),_=e.getOption(r,"targetAddress",n.A1);return t.formatReference(this._docModel,_,this._sheet1Ref,this._sheet2Ref,u,c)},S.prototype.resolveCutPasteCells=function(e,t,s,l){var r=l.sheet,o=this._cell1Ref&&this._cell2Ref,n=this.getRange3D(l),a=t.start[0]===s.start[0],f=t.start[1]===s.start[1],u=!!a||!f&&null,c=t.start.get(!u)<s.start.get(!u),_=n.toRange(),R=_.overlaps(s),g=null,d=null,v=null;if(!n||!n.isSheet(r))return null;if(o?t.contains(new i(this._cell1Ref.toAddress(),this._cell2Ref.toAddress())):this._cell1Ref&&t.containsAddress(this._cell1Ref.toAddress())){var m=this._cell1Ref?this._cell1Ref.clone():null,y=this._cell2Ref?this._cell2Ref.clone():null;return this.relocateRange(t.start,s.start,!1),d=this._cell1Ref?this._cell1Ref.clone():null,v=this._cell2Ref?this._cell2Ref.clone():null,this._cell1Ref=m,this._cell2Ref=y,e.formatReference(this._docModel,s.start,this._sheet1Ref,this._sheet2Ref,d,v)}if(o&&this._cell1Ref.getIndex(u)>=t.start.get(u)&&this._cell2Ref.getIndex(u)<=t.end.get(u)){if(!a&&!f)return null;var b=new h(_).difference(t).first(),x=t.intersect(_);if(!x)return null;var T=this._cell1Ref.col,M=this._cell1Ref.row,N=this._cell2Ref.col,S=this._cell2Ref.row,w=t.contains(u?_.headerRow():_.leadingCol()),C=t.contains(u?_.footerRow():_.trailingCol()),O=s.contains(u?_.headerRow():_.leadingCol()),A=s.contains(u?_.footerRow():_.trailingCol()),D=x.start[0]-t.start[0],I=x.start[1]-t.start[1],E=t.cols()-D-x.cols(),F=t.rows()-I-x.rows();return w?A?(T=b.start[0],M=b.start[1],N=s.start[0]+D+x.cols()-1,S=s.start[1]+I+x.rows()-1):!R&&c||(T=D>0||!c?s.start[0]+D:b.start[0],M=I>0||!c?s.start[1]+I:b.start[1],N=Math.max(x.cols(),b.end[0]),S=Math.max(x.rows(),b.end[1])):C&&(O?(T=Math.min(b.start[0],s.start[0]+D),M=Math.min(b.start[1],s.start[1]+I),N=E>0&&c?s.start[0]+D+x.cols()-1:b.end[0],S=F>0&&c?s.start[1]+I+x.rows()-1:b.end[1]):(R||c)&&(T=Math.min(b.start[0],s.start[0]+D),M=Math.min(b.start[1],s.start[1]+I),N=E>0||c?s.start[0]+D+x.cols()-1:b.end[0],S=F>0||c?s.start[1]+I+x.rows()-1:b.end[1])),(g=i.create(T,M,N,S))&&g.equals(_)?null:(d=g&&p.create(g.start,this._cell1Ref.absCol,this._cell1Ref.absRow),v=g&&this._cell2Ref&&p.create(g.end,this._cell2Ref.absCol,this._cell2Ref.absRow),e.formatReference(this._docModel,s.start,this._sheet1Ref,this._sheet2Ref,d,v))}return null};var w=N.extend(function(e,t,s,l){N.call(this,"name",e,s,null,l),this._value=t});w.prototype._getNameModelFromSheet=function(e,t){var s="number"==typeof e?this._docModel.getSheetModel(e):null;return s?s.getNameCollection().getName(t):null},w.prototype._resolveNameModel=function(e,t){return this.isOwnDoc()?this._sheet1Ref?this._getNameModelFromSheet(this._sheet1Ref.sheet,e):0===this._extDocRef?this._docModel.getNameCollection().getName(e):this._getNameModelFromSheet(t,e)||this._docModel.getNameCollection().getName(e):null},w.prototype._resolveTableModel=function(e){if(!this.isOwnDoc())return null;if(this._sheet1Ref){var t=this._sheet1Ref.sheet,s="number"==typeof t?this._docModel.getSheetModel(t):null;return s?s.getTableCollection().getTable(e):null}return this._docModel.getTable(e)},w.prototype.getValue=function(){return this._value},w.prototype.resolveNameModel=function(e){return this._resolveNameModel(this._value,e)},w.prototype.resolveTableModel=function(){return this._resolveTableModel(this._value)},w.prototype.getText=function(t,s){var l=this._resolveSheetRefs(s),r=e.getStringOption(s,"label",this._value);return t.formatName(this._docModel,this._extDocRef,l.s1,r)},w.prototype.debugText=function(){return this.debugSheetPrefix()+this._value},w.prototype.resolveRelabeledName=function(e,t,s,l,r){if(s.toLowerCase()!==this._value.toLowerCase())return null;var o=this._resolveNameModel(l,r);if(o)return("number"==typeof t?this._docModel.getSheetModel(t):null)!==o.getSheetModel()?null:this.getText(e,{label:l})};var C=N.extend(function(e,t,s){N.call(this,"macro",e,s,null,null),this._value=t});C.prototype.getValue=function(){return this._value},C.prototype.getText=function(t,s){var l=this._resolveSheetRefs(s),r=e.getStringOption(s,"label",this._value);return t.formatMacro(this._docModel,this._extDocRef,l.s1,r)},C.prototype.debugText=function(){return this.debugSheetPrefix()+this._value};var O=d.extend(function(t,s,l){d.call(this,"table"),this._docModel=t,this._tableName=s,this._regionKey=e.getStringOption(l,"regionKey",null),this._regionKeys=this._regionKey?this._regionKey.split(","):null,this._col1Name=e.getStringOption(l,"col1Name",null),this._col2Name=this._col1Name?e.getStringOption(l,"col2Name",null):null,this._openWs=e.getBooleanOption(l,"openWs",!1),this._closeWs=e.getBooleanOption(l,"closeWs",!1),this._sepWs=e.getBooleanOption(l,"sepWs",!1)});return O.prototype._resolveRangeData=function(e){var t=this.resolveTableModel();if(!t)return null;var s=this.getRegionKey(),l=!e&&"ROW"===s?t.getRange():t.getRegionRange(s,e);if(!l)return null;var r=t.getRange();if(this._col1Name){var o=t.findColumnByName(this._col1Name);if(null!==o)if(this._col2Name){var n=t.findColumnByName(this._col2Name);r=null!==n?r.colRange(Math.min(o,n),Math.abs(o-n)+1):null}else r=r.colRange(o);else r=null}return r?{tableModel:t,tableRange:l.intersect(r)}:null},O.prototype.getTableName=function(){return this._tableName},O.prototype.getRegionKey=function(){return this._regionKey||"DATA"},O.prototype.hasColumnRange=function(){return!!this._col1Name},O.prototype.resolveTableModel=function(){return this._docModel.getTable(this._tableName)},O.prototype.getRange3D=function(e){var t=this._resolveRangeData(e);if(!t)return null;var s=t.tableModel.getSheetModel().getIndex();return a.createFromRange(t.tableRange,s)},O.prototype.getText=function(t,s){function l(e){return e?" ":""}var r=e.getStringOption(s,"tableName",this._tableName),o=this._openWs||this._closeWs;if(!this._regionKeys&&!this._col1Name)return r+(t.UI||"ooxml"!==t.REF_SYNTAX?"":"["+l(o)+"]");var n=this._regionKeys&&1===this._regionKeys.length?this._regionKeys[0]:null,i=[];if(t.UI&&"ROW"===n){var a="";this._col2Name?a="["+t.encodeTableColumn(this._col1Name)+"]:["+t.encodeTableColumn(this._col2Name)+"]":this._col1Name&&(a=t.isSimpleTableColumn(this._col1Name)?this._col1Name:"["+t.encodeTableColumn(this._col1Name)+"]"),i.push("@"+a)}else!n||o||this._col1Name?this._regionKeys||!this._col1Name||this._col2Name||o||/^\s|\s$/.test(this._col1Name)?(this._regionKeys&&this._regionKeys.forEach(function(e){i.push("["+t.getTableRegionName(e)+"]")}),this._col2Name?i.push("["+t.encodeTableColumn(this._col1Name)+"]:["+t.encodeTableColumn(this._col2Name)+"]"):this._col1Name&&i.push("["+t.encodeTableColumn(this._col1Name)+"]")):i.push(t.encodeTableColumn(this._col1Name)):i.push(t.getTableRegionName(n));var h=!0;if(t.UI&&e.getBooleanOption(s,"unqualifiedTables",!1)&&this._col1Name&&!this._col2Name&&(!this._regionKeys||"ROW"===n)){var f=this.resolveTableModel(),u=e.getIntegerOption(s,"refSheet",null);if(f&&f.getSheetModel().getIndex()===u){var c=e.getOption(s,"targetAddress",null);h=!c||!f.containsCell(c)}}return(h?r:"")+"["+l(this._openWs)+i.join(t.SEP+l(this._sepWs))+l(this._closeWs)+"]"},O.prototype.debugText=function(){var e=this._tableName;return this._regionKeys&&(e+=this._regionKeys.map(function(e){return"[#"+e+"]"})),this._col1Name&&(e+="["+this._col1Name+"]"),this._col2Name&&(e+=":["+this._col2Name+"]"),e},O.prototype.resolveDeletedSheet=function(e,t){var s=this.resolveTableModel();return s&&s.getSheetModel().getIndex()!==t?null:e.getErrorName(r.REF)},O.prototype.resolveRenamedSheet=function(e,t,s,l){if(!l)return null;var o=this.resolveTableModel();if(!o)return e.getErrorName(r.REF);var n=l[o.getName()];return n?this.getText(e,{tableName:n}):null},O.prototype.resolveMovedCells=function(e,t,s){var l=this._resolveRangeData(null);if(!l)return e.getErrorName(r.REF);if(t!==l.tableModel.getSheetModel().getIndex())return null;var o=l.tableRange;if(!c.transformRange(o,s))return e.getErrorName(r.REF);if(this.hasColumnRange()){var n=c.transformRange(o.leadingCol(),s),i=c.transformRange(o.trailingCol(),s);if(!n||!i)return e.getErrorName(r.REF)}return null},{FixedToken:v,OperatorToken:m,SeparatorToken:y,ParenthesisToken:b,LiteralToken:x,MatrixToken:T,FunctionToken:M,SheetRefToken:N,ReferenceToken:S,NameToken:w,MacroToken:C,TableToken:O}});