define("io.ox/office/spreadsheet/model/formula/tokenarray",["io.ox/office/tk/utils","io.ox/office/tk/container/valueset","io.ox/office/tk/container/valuemap","io.ox/office/editframework/utils/attributeutils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,n,s,o,i){"use strict";function a(t){var r=e.getIntegerOption(t,"sheet"),n=!e.getBooleanOption(t,"relSheet",!1);return"number"==typeof r?new d(r,n):null}function l(e,t){this._docModel=e.getDocModel(),this._sheetModel=e===this._docModel?null:e,this._changeHandlers=null,this._allTokens=[],this._sheet3dTokens=[],this._refTokens=[],this._nameTokens=[],this._tokenTypeSet={},this._wrapReferences=t===g.NAME,this._freezeRelRefs=t===g.NAME,this._detectCircular=t===g.CELL,this._unqualifiedTables=t===g.CELL,this._compileDesc=null,this._resultCache=null,this._interpreting=null}var h=s.UpdateMode,u=s.Address,c=s.RangeArray,p=s.Range3DArray,f=o.CellRef,d=o.SheetRef,g=o.FormulaType,k=i.SeparatorToken,m=i.ParenthesisToken,T=i.ReferenceToken,v=i.NameToken;return l.prototype._registerToken=function(e){this._tokenTypeSet[e.getType()]=!0,e.hasSheetRef&&e.hasSheetRef()&&this._sheet3dTokens.push(e),e instanceof T&&this._refTokens.push(e),e instanceof v&&this._nameTokens.push(e)},l.prototype._invokeChangeHandlers=function(e,t){this._compileDesc=null,this.clearResultCache(),this._changeHandlers&&this._changeHandlers.forEach(function(r){r.call(this,e,t)},this)},l.prototype._resolveChangedFormula=function(e,t){var r=this._docModel.getFormulaGrammar(e),n="",s="";return this._allTokens.forEach(function(e){var o=e.getText(r),i=t.call(this,e,r);n+=o,s+=null===i?o:i},this),n===s?null:{old:n,new:s}},l.prototype._resolveRefSheet=function(t){return this._sheetModel?this._sheetModel.getIndex():e.getIntegerOption(t,"refSheet",null)},l.prototype._extendWithOwnOptions=function(e){return _.extend({wrapReferences:this._wrapReferences},e,{refSheet:this._resolveRefSheet(e),detectCircular:this._detectCircular,unqualifiedTables:this._unqualifiedTables})},l.prototype._compileTokens=function(e){return this._docModel.getFormulaCompiler().compileTokens(e)},l.prototype._isInterpreting=function(e){return!!this._interpreting&&this._interpreting.has(e)},l.prototype._lockInterpreting=function(e,r){var n=this._interpreting||(this._interpreting=new t("key()"));try{return n.insert(e),r.call(this)}finally{n.remove(e)}},l.prototype.getDocModel=function(){return this._docModel},l.prototype.getSheetModel=function(){return this._sheetModel},l.prototype.empty=function(){return 0===this._allTokens.length},l.prototype.hasToken=function(e){return e in this._tokenTypeSet},l.prototype.hasRefTokens=function(){return this.hasToken("ref")||this.hasToken("name")||this.hasToken("table")},l.prototype.hasSheet3dTokens=function(){return this._sheet3dTokens.length>0},l.prototype.getFormula=function(e,t){var r=this._docModel.getFormulaGrammar(e),n=this._extendWithOwnOptions(t);return this._allTokens.reduce(function(e,t){return e+t.getText(r,n)},"")},l.prototype.resolveStringList=function(){var e=[],t="";return this._allTokens.every(function(r){switch(r.getType()){case"lit":return t+="L",e.push(r.getValue()),_.isString(_.last(e));case"sep":return t+=",",!0;case"ws":return!0;default:return t+="I",!1}}),/^L(,L)*$/.test(t)?e:null},l.prototype.resolveRangeList=function(t){var r=e.getOption(t,"targetAddress",u.A1),n=new p;if(this._isInterpreting(r))return n;var s=e.getStringOption(t,"resolveNames",null);if(!(s?this.hasRefTokens():this.hasToken("ref")))return n;t=this._extendWithOwnOptions(t);var o="";return this._allTokens.every(function(e){switch(e.getType()){case"ref":var i=e.getRange3D(t);return!(!i||!i.singleSheet())&&(n.push(i),o+="R",!0);case"name":var a=s?e.resolveNameModel(t.refSheet):null;if(!a)return!1;var l=_.clone(t);l.refAddress=u.A1;var h=this._lockInterpreting(r,function(){var e=a.getTokenArray();switch(s){case"simple":return e.resolveRangeList(l);case"interpret":var t=e.interpretFormula("ref",l);return t.value instanceof p?t.value:null;default:return null}});return!(!h||h.empty())&&(n.append(h),o+="R",!0);case"table":var c=s?e.getRange3D(r):null;return!!c&&(n.push(c),o+="R",!0);case"open":return o+="<",!0;case"close":return o+=">",!0;case"sep":return o+=",",!0;case"ws":return!0;default:return!1}},this)&&/^(R(,R)*|<R(,R)*>)$/.test(o)?n:n.clear()},l.prototype.extractRanges=function(t){var r=e.getOption(t,"targetAddress",u.A1),n=[];if(n.circular=!1,this._isInterpreting(r))return n.circular=!0,n;var s=e.getBooleanOption(t,"resolveNames",!1);return(s?this.hasRefTokens():this.hasToken("ref"))?(t=this._extendWithOwnOptions(t),this._allTokens.forEach(function(e,o){switch(e.getType()){case"ref":var i=e.getRange3D(t);i&&n.push({range:i,index:o,type:"ref"});break;case"name":var a=s?e.resolveNameModel(t.refSheet):null;if(!a)return;var l=_.clone(t);l.refAddress=u.A1;var h=this._lockInterpreting(r,function(){return a.getTokenArray().extractRanges(l)});h.forEach(function(e){n.push({range:e.range,index:o,type:"name"})}),n.circular=n.circular||h.circular;break;case"table":var c=s?e.getRange3D(r):null;c&&n.push({range:c,index:o,type:"table"})}},this),n):n},l.prototype.resolveOperation=function(t,r,n,s){var o=this._resolveRefSheet(),i=function(){switch(r.type){case h.DELETE_SHEET:return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(t,function(e,t){return e.resolveDeletedSheet(t,r.sheet,o)}):null;case h.RENAME_SHEET:return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(t,function(e,t){return e.resolveRenamedSheet(t,r.sheet,r.sheetName,r.tableNames)}):null;case h.RELABEL_NAME:return 0===this._nameTokens.length?null:this._resolveChangedFormula(t,function(e,t){return e.resolveRelabeledName(t,r.sheet,r.oldLabel,r.newLabel,o)});case h.MOVE_CELLS:if(!this.hasToken("ref")&&!this.hasToken("table"))return null;var n={refSheet:o,freezeRelRefs:this._freezeRelRefs};return r.relocate&&(n.refAddress=r.relocate.from,n.targetAddress=r.relocate.to),this._resolveChangedFormula(t,function(e,t){return e.resolveMovedCells(t,r.sheet,r.moveDescs,n)});case h.CUT_PASTE:if(!this.hasToken("ref"))return null;var s={refSheet:o,sheet:r.sourceSheet};return this._resolveChangedFormula(t,function(e,t){return e.resolveCutPasteCells(t,r.sourceRange,r.targetRange,s)})}return e.error('TokenArray.resolveOperation(): unknown operation type "'+r.type+'"'),null}.call(this);return i&&n.call(s,i.new,i.old),this},l.prototype.resolveOperationProperty=function(e,t,r,n,s){return this.resolveOperation(e,t,function(e,t){n[r]=e,s&&(s[r]=t)})},l.prototype.resolveOperationAttribute=function(e,t,r,s,o,i){return this.resolveOperation(e,t,function(e,t){n.insertAttribute(o,r,s,e),i&&n.insertAttribute(i,r,s,t)})},l.prototype.registerChangeHandler=function(e){return(this._changeHandlers||(this._changeHandlers=[])).push(e),this},l.prototype.unregisterChangeHandler=function(e){return this._changeHandlers&&(this._changeHandlers=_.without(this._changeHandlers,e)),this},l.prototype.setTokens=function(e){return this.empty()&&0===e.length?this:(this._allTokens=e.slice(),this._refTokens=[],this._sheet3dTokens=[],this._tokenTypeSet={},this._allTokens.forEach(this._registerToken,this),this._invokeChangeHandlers(null),this)},l.prototype.clearTokens=function(){return this.setTokens([])},l.prototype.parseFormula=function(t,r,n){n=this._extendWithOwnOptions(n);var s=this._docModel.getFormulaParser().parseFormula(t,r,n),o=_.pluck(s,"token");if(e.getBooleanOption(n,"autoCorrect",!1)){var i=this._compileTokens(o);if(!i.error)for(var a=0;a<i.missingClose;a+=1)o.push(new m(!1))}return this.setTokens(o),s},l.prototype.refreshAfterImport=function(e){return this.hasToken("bad")||this.hasToken("name")?this.parseFormula("op",this.getFormula("op"),e):this._sheet3dTokens.length>0&&(this._sheet3dTokens.forEach(function(e){e.refreshSheets()}),this._compileDesc=null,this.clearResultCache()),this},l.prototype.modifyToken=function(e,t,r,n){var s=this._allTokens[e];return s&&s.isType(t)&&r.call(n,s,e)&&this._invokeChangeHandlers(s,e),this},l.prototype.appendToken=function(e){return this._allTokens.push(e),this._registerToken(e),this._invokeChangeHandlers(e,this._allTokens.length-1),this},l.prototype.appendAddress=function(t,r){var n=e.getBooleanOption(r,"abs",!1),s=f.create(t,n,n),o=a(r);return this.appendToken(new T(this._docModel,s,null,o))},l.prototype.appendRange=function(t,r){var n=this._docModel.isColRange(t),s=this._docModel.isRowRange(t),o=e.getBooleanOption(r,"abs",!1),i=f.create(t.start,o||s,o||n&&!s),l=t.single()?null:f.create(t.end,o||s,o||n&&!s),h=a(r);return this.appendToken(new T(this._docModel,i,l,h))},l.prototype.appendRangeList=function(t,r){var n=t.length>1&&e.getBooleanOption(r,"parentheses",!1);return n&&this.appendToken(new m(!0)),t.forEach(function(e,t){t>0&&this.appendToken(new k),this.appendRange(e,r)},this),n&&this.appendToken(new m(!1)),this},l.prototype.relocateRanges=function(e,t){if(e.equals(t))return!1;var r=!1;return this._refTokens.forEach(function(n){n.relocateRange(e,t,this._wrapReferences)&&(r=!0)},this),r&&this._invokeChangeHandlers(null),r},l.prototype.transformSheet=function(e,t){if(t===e)return!1;var r=!1;return this._sheet3dTokens.forEach(function(n){n.transformSheet(e,t)&&(r=!0)},this),r&&this._invokeChangeHandlers(null),r},l.prototype.compileFormula=function(){return this._compileDesc||(this._compileDesc=this._compileTokens(this._allTokens))},l.prototype.getDependencies=function(e,r,n){var i={depRanges:new p,rootRanges:new p,nameSet:new t("getUid()"),tableSet:new t("getUid()"),missingNames:{},missingFuncs:{},recalc:null,circular:!1},a=this.compileFormula();if(a.error)return i;var l=r instanceof u?r:null;if(this._isInterpreting(l||e))return i.circular=!0,i;_.extend(i.missingFuncs,a.missingFuncs),i.recalc=a.root.recalc,n=this._extendWithOwnOptions(n);var h=l?_.extend({},n,{refAddress:e,targetAddress:l}):null,f=l?null:c.get(r),d=function t(a){var c=a.token;if(c.isType("ref")){if(h){var d=c.getRange3D(h);return d?new p(d):null}return c.getExpandedRanges(e,f,n)}if(c.isType("name")){var g=c.resolveNameModel(n.refSheet);if(!g)return i.missingNames[s.getNameKey(c.getValue())]=!0,null;var k=this._lockInterpreting(l||e,function(){return g.getTokenArray().getDependencies(u.A1,r,n)});return i.depRanges.append(k.depRanges),i.nameSet.insert(g),i.nameSet.merge(k.nameSet),i.tableSet.merge(k.tableSet),_.extend(i.missingNames,k.missingNames),_.extend(i.missingFuncs,k.missingFuncs),i.recalc=o.getRecalcMode(i.recalc,k.recalc),i.circular=i.circular||k.circular,k.rootRanges}if(c.isType("table")){var m=c.resolveTableModel();if(!m)return null;i.tableSet.insert(m);var T=c.getRange3D(l);return T?new p(T):null}if(a.operands&&a.signature){var v=new p;return a.signature.forEach(function(e,r){var n=t.call(this,a.operands[r]);switch(e.depSpec){case"pass":v.append(n);break;case"skip":break;default:i.depRanges.append(n)}},this),v}return null}.call(this,a.root);return i.rootRanges.append(d),i},l.prototype.interpretFormula=function(t,n){function s(){return a.interpretTokens(t,i.root,n)}var i=this.compileFormula(),a=this._docModel.getFormulaInterpreter();if(i.error)return a.createErrorResult(t,i.error);var l=e.getOption(n,"targetAddress",u.A1);if(this._isInterpreting(l))return a.createWarnResult(t,o.CIRCULAR_ERROR);var h=(n=this._extendWithOwnOptions(n)).cacheResult&&"always"!==i.root.recalc?this._resultCache||(this._resultCache=new r):null,c=function(){if(!h)return null;var e=this.hasToken("name"),t=e||i.root.relColRef,r=t&&n.refAddress?n.refAddress[0]:0,s=t?l[0]:0,o=e||i.root.relRowRef,a=o&&n.refAddress?n.refAddress[1]:0,c=o?l[1]:0;return u.key(r,a)+":"+u.key(s,c)}.call(this);return this._lockInterpreting(l,function(){return h?h.getOrCreate(c,s):s()})},l.prototype.clearResultCache=function(){return this._resultCache=null,this},l});