define("io.ox/office/spreadsheet/model/model",["io.ox/office/tk/utils","io.ox/office/tk/utils/iterator","io.ox/office/tk/container/valueset","io.ox/office/tk/container/valuemap","io.ox/office/tk/locale/localedata","io.ox/office/editframework/model/viewattributesmixin","io.ox/office/textframework/utils/dom","io.ox/office/textframework/model/editor","io.ox/office/textframework/model/listhandlermixin","io.ox/office/textframework/model/updatelistsmixin","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/operationcontext","io.ox/office/spreadsheet/model/operationgenerator","io.ox/office/spreadsheet/model/numberformatter","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/listcollection","io.ox/office/spreadsheet/model/sheetmodel","io.ox/office/spreadsheet/model/modelattributesmixin","io.ox/office/spreadsheet/model/formula/parser/formularesource","io.ox/office/spreadsheet/model/formula/parser/formulagrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/interpret/formulacompiler","io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter","io.ox/office/spreadsheet/model/formula/deps/dependencymanager"],function(e,t,n,r,i,o,a,s,l,u,c,h,g,p,d,f,E,m,S,T,C,v,A,O,y,R){"use strict";var I=t.ArrayIterator,N=t.TransformIterator,x=g.SheetType,M=g.UpdateMode,b=g.Address,w=g.Interval,D=g.Range,L=g.RangeArray,H=g.Range3DArray,F={activeSheet:{def:-1,validate:function(t){return t>=-1&&t<this.getSheetCount()?t:e.BREAK}},rcStyle:{def:!1}},k={"change:attributes":"change:sheet:attributes","change:viewattributes":"change:sheet:viewattributes"},U=e.makeSet([h.SET_ATTRIBUTES,h.DELETE,h.MOVE,h.TEXT_INSERT,h.TAB_INSERT,h.HARDBREAK_INSERT,h.PARA_INSERT,h.PARA_SPLIT,h.PARA_MERGE,h.INSERT_LIST,h.DELETE_LIST]),B=c.getDebugUrlFlag("spreadsheet:failing-import");return s.extend({constructor:function(V){function G(e,t){de[0]=e-1,de[1]=t-1}function P(e){return(e=_.isNumber(e)?e:_.isString(e)?te.getSheetIndex(e):-1)>=0&&e<re.length?re[e]:null}function K(e,t){var n=te.getSheetModel(e),r=_.isNumber(t)?te.getSheetModel(t):null;return 0===e.length?"sheet:name:empty":/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]|'$/.test(e)?"sheet:name:invalid":!_.isObject(n)||_.isObject(r)&&n===r?null:"sheet:name:used"}function W(e,t){return null===K(e,t)}function j(e,t){var n=K(e,t);return null===n?$.when():g.makeRejected(n)}function X(e,t,n,r){if(!te.canInsertSheet())return null;te.trigger("insert:sheet:before",e);var i=te.getActiveSheet();(i=e<=i?i+1:-1)>=0&&te.setActiveSheet(-1);var o=new S(te,t,r),a=o.getUid(),s=o.getDrawingCollection().getContainerNode();return re.splice(e,0,{model:o,uid:a,name:n,node:s}),me.insertBefore(s,me.childNodes.item(e)),e===re.length?ie.insert(a,e):ie.clear(),i>=0&&te.setActiveSheet(i),te.trigger("insert:sheet:after",e,o),te.trigger("transform:sheet",null,e),te.listenTo(o,"triggered",function(e,t){var n=k[t]||t;te.trigger.apply(te,[n,o.getIndex()].concat(_.toArray(arguments).slice(2)))}),o}function Y(e){if(0===arguments.length){var t=te.getActiveSheet(),n=te.getSheetModel(t);return n?{sheet:t,selection:n.getViewAttribute("selection")}:null}var r=te.getSheetModel(e.sheet);r&&(te.setActiveSheet(e.sheet),r.setViewAttribute("selection",e.selection))}function z(e,t,n){te.registerContextOperationHandler(e,function(e){t[n](e)})}function J(t,n,r){var i=e.getBooleanOption(r,"allowDoc",!1);return te.registerContextOperationHandler(t,function(e){var t=i&&!e.has("sheet"),r=t?null:e.getInt("sheet"),o=t?te:te.getSheetModel(r);return e.ensure(o,"missing sheet"),n.call(te,e,o,r)})}function q(e,t,n,r){J(e,function(e,r){r[t]()[n](e)},r)}function Q(e,t){return te.registerContextOperationHandler(e,function(e){var n=e.getPos("start");e.ensure(n.length>=2,"invalid drawing start position");var r=te.getSheetModel(n[0]);return e.ensure(r,"invalid sheet index"),t.call(te,e,r.getDrawingCollection(),n.slice(1))})}function Z(e,t){Q(e,function(e,n,r){n[t](e,r)})}function ee(t,n,r){var i=e.getStringOption(r,"type",null);Q(t,function(e,t,r){var o=t.getModelDescriptor(r);e.ensure(o,"invalid drawing position"),e.ensure(!i||i===o.model.getType(),"invalid drawing type"),e.ensure(0===o.remaining.length,"invalid drawing start position"),o.model[n](e)})}var te=this,ne=V.getFileFormat(),re=[],ie=new r,oe=new n("getKey()"),ae=new r,se=null,le=null,ue=null,ce=null,he=null,ge=null,pe=null,de=b.A1.clone(),fe=[],Ee=null,me=null;s.call(this,V,{contextClass:p,selectionStateHandler:Y,defaultStyleFamily:"cell",slideMode:!0}),o.call(this,F),l.call(this,V),u.call(this,V);var Se=this.createDebouncedMethod("SpreadsheetModel.sendActiveSelectionDebounced",null,function(){var e=Y();e&&V.updateUserData({sheet:e.sheet,ranges:ue.formatRangeList("op",e.selection.ranges),drawings:e.selection.drawings})},{delay:250});this.postProcessImport=function(){return 0===re.length?$.Deferred().reject():(this.getCellStyles().createMissingStyles(),this.iterateArraySliced(re,function(e){return e.model.postProcessImport()},"SpreadsheetModel.postProcessImport"))},this._registerTableModel=function(e){e.isAutoFilter()||oe.insert(e)},this._unregisterTableModel=function(e){e.isAutoFilter()||oe.remove(e)},this.getNumberFormatter=function(){return se},this.getFormulaResource=function(){return C.create(ne,i.LOCALE)},this.getFormulaGrammar=function(e){return ae.getOrCreate(e,function(){var t=e.split("!"),n=t[1]?"rc"===t[1]:this.getViewAttribute("rcStyle"),r=t[0].split(":"),i=r[1]||ne;return v.create(r[0],i,n)},this)},this.getFormulaParser=function(){return ue},this.getFormulaCompiler=function(){return ce},this.getFormulaInterpreter=function(){return he},this.getNameCollection=function(){return ge},this.getListCollection=function(){return pe},this.getDependencyManager=function(){return le},this.getMaxCol=function(){return de[0]},this.getMaxRow=function(){return de[1]},this.getMaxIndex=function(e){return de.get(e)},this.getMaxAddress=function(){return de.clone()},this.getSheetRange=function(){return D.createFromAddresses(b.A1,de)},this.isColRange=function(e){return 0===e.start[1]&&e.end[1]===de[1]},this.makeColRange=function(e){var t="number"==typeof e;return D.create(t?e:e.first,0,t?e:e.last,de[1])},this.makeColRanges=function(e){return L.map(e,this.makeColRange.bind(this))},this.isRowRange=function(e){return 0===e.start[0]&&e.end[0]===de[0]},this.makeRowRange=function(e){var t="number"==typeof e;return D.create(0,t?e:e.first,de[0],t?e:e.last)},this.makeRowRanges=function(e){return L.map(e,this.makeRowRange.bind(this))},this.isFullRange=function(e,t){return t?this.isColRange(e):this.isRowRange(e)},this.makeFullRange=function(e,t){return t?this.makeColRange(e):this.makeRowRange(e)},this.makeFullRanges=function(e,t){return t?this.makeColRanges(e):this.makeRowRanges(e)},this.isValidAddress=function(e){return e[0]>=0&&e[0]<=de[0]&&e[1]>=0&&e[1]<=de[1]},this.isValidRange=function(e){return e.start[0]>=0&&e.start[0]<=e.end[0]&&e.end[0]<=de[0]&&e.start[1]>=0&&e.start[1]<=e.end[1]&&e.end[1]<=de[1]},this.createInterval=function(t,n,r){if(!_.isObject(t))return null;var i=r?"start":"first",o=r?"end":"last",a=this.getMaxIndex(n),s=t[i];if(!e.isFiniteNumber(s)||s<0||s>a)return null;if(!(o in t))return new w(s);var l=t[o];return!e.isFiniteNumber(l)||l<s||l>a?null:new w(s,l)},this.createAddress=function(t){return _.isArray(t)&&2===t.length?!e.isFiniteNumber(t[0])||t[0]<0||t[0]>de[0]?null:!e.isFiniteNumber(t[1])||t[1]<0||t[1]>de[1]?null:new b(t[0],t[1]):null},this.createRange=function(e){if(!_.isObject(e))return null;var t=this.createAddress(e.start);if(!t)return null;if(!("end"in e))return new D(t);var n=this.createAddress(e.end);return!n||n[0]<t[0]||n[1]<t[1]?null:new D(t,n)},this.createRangeArray=function(e){if(!_.isArray(e)||0===e.length)return null;var t=new L;return e.every(function(e){if(e=this.createRange(e))return t.push(e),!0},this),e.length===t.length?t:null},this.getBoundedMovedRange=function(t,n,r){return n=e.minMax(n,-t.start[0],de[0]-t.end[0]),r=e.minMax(r,-t.start[1],de[1]-t.end[1]),D.create(t.start[0]+n,t.start[1]+r,t.end[0]+n,t.end[1]+r)},this.getCroppedMovedRange=function(e,t,n){var r=Math.max(0,e.start[0]+t),i=Math.max(0,e.start[1]+n),o=Math.min(de[0],e.end[0]+t),a=Math.min(de[1],e.end[1]+n);return r<=o&&i<=a?D.create(r,i,o,a):null},this.getMaxSheetNameLength=function(){return V.isOOXML()?31:65535},this.hasSheet=function(e){return null!==P(e)},this.getSheetName=function(e){var t=P(e);return t?t.name:null},this.getSheetIndex=function(t){return t=t.toLowerCase(),e.findFirstIndex(re,function(e){return e.name.toLowerCase()===t})},this.getSheetIndexOfModel=function(t){var n=t.getUid?t.getUid():t;return ie.getOrCreate(n,function(){return e.findFirstIndex(re,function(e){return e.uid===n})})},this.getSheetModel=function(e){var t=P(e);return t?t.model:null},this.getSheetCount=function(n){var r=e.getBooleanOption(n,"supported",!1),i=e.getBooleanOption(n,"cells",!1),o=e.getBooleanOption(n,"visible",null);if(!r&&!i&&null===o)return re.length;var a=this.createSheetIterator({supported:r,cells:i,visible:o});return t.reduce(0,a,function(e){return e+1})},this.createSheetIterator=function(t){var n=e.getIntegerOption(t,"first",0),r=e.getIntegerOption(t,"last",re.length-1),i=e.getBooleanOption(t,"reverse",!1),o=new I(re,{begin:i?r:n,end:i?n-1:r+1,reverse:i}),a=e.getBooleanOption(t,"supported",!1),s=e.getBooleanOption(t,"cells",!1),l=e.getBooleanOption(t,"visible",null),u=0;return new N(o,function(e,t){var n=e.model;return a&&!n.isSupportedType()?null:s&&!n.isCellType()?null:null!==l&&l!==n.isVisible()?null:(t={value:n,name:e.name,sheet:t.index,index:u},u+=1,t)})},this.findVisibleSheet=function(e,t){var n=function(){switch(t){case"next":return{first:e,supported:!0,visible:!0};case"prev":return{last:e,reverse:!0,supported:!0,visible:!0}}return null}();if(n){var r=this.createSheetIterator(n).next();return r.done?-1:r.sheet}var i=this.findVisibleSheet(e,"next");return i<0?this.findVisibleSheet(e,"prev"):i},this.getActiveSheet=function(){return this.getViewAttribute("activeSheet")},this.setActiveSheet=function(e){return this.setViewAttribute("activeSheet",e)},this.canInsertSheet=function(){return c.MAX_SHEET_COUNT<1||re.length<c.MAX_SHEET_COUNT},this.generateUnusedSheetName=function(){for(var e="",t=re.length;0===e.length||this.hasSheet(e);)e=g.getSheetName(t),t+=1;return e},this.hasName=function(e){return ge.hasName(e)||re.some(function(t){return t.model.getNameCollection().hasName(e)})},this.getAllNames=function(t){var n=ge.getAllNames(t);return e.getBooleanOption(t,"skipLocal",!1)||re.forEach(function(e){n=n.concat(e.model.getNameCollection().getAllNames(t))}),n},this.hasTable=function(e){return oe.hasKey(g.getTableKey(e))},this.getTable=function(e){return oe.get(g.getTableKey(e),null)},this.getAllTables=function(e){return re.reduce(function(t,n){return t.concat(n.model.getTableCollection().getAllTables(e))},[])},this.getRangeContents=function(t,n){var r=e.getIntegerOption(n,"maxCount",null,1),i=[];return i.count=0,t=H.filter(t,function(t){return!(!this.hasSheet(t.sheet1)||!t.singleSheet())||(e.warn("SpreadsheetModel.getRangeContents(): invalid sheet index in range address"),!1)},this),n=_.clone(n),H.forEach(t,function(t){var o=this.getSheetModel(t.sheet1).getCellCollection(),a=t.toRange(),s=o.getRangeContents(a,n);if(i=i.concat(s),i.count+=s.count,r===i.count)return e.BREAK;r&&(n.maxCount-=s.count)},this),i},this.sendOperations=_.wrap(this.sendOperations,function(t,n,r){return e.getBooleanOption(r,"defer",!1)?(fe=fe.concat(d.getArray(n,r)),!0):t.call(this,n,r)}),this.createAndApplyOperations=_.wrap(this.createAndApplyOperations,function(e,t,n){return fe.length>0&&(this.sendOperations(fe),fe=[]),e.call(this,t,n)}),this.createSheetOperationGenerator=function(e){return new d(this,e)},this.createAndApplySheetOperations=g.profileAsyncMethod("SpreadsheetModel.createAndApplySheetOperations()",function(e,t){return t=_.extend({applyImmediately:!0,undoOptions:{preventSelectionChange:!0}},t,{generatorClass:d}),this.createAndApplyOperations(function(t){return this.setBlockKeyboardEvent(!0),te.convertToPromise(e.call(this,t)).always(function(){te.setBlockKeyboardEvent(!1),t.logCacheUsage()})},t)}),this.generateOperationsForSheets=function(e,t,n){var r=e.getSheetIndex();return this.iterateArraySliced(t,function(t){return e.setSheetIndex(t),n.call(te,te.getSheetModel(t),t)},"SpreadsheetModel.generateOperationsForSheets").always(function(){e.setSheetIndex(r)})},this.generateOperationsForAllSheets=function(t,n,r){var i=t.getSheetIndex(),o=e.getIntegerOption(r,"skipSheet",null);return this.iterateSliced(this.createSheetIterator(r),function(e,r){if(r.sheet!==o)return t.setSheetIndex(r.sheet),n.call(te,e,r.sheet)},"SpreadsheetModel.generateOperationsForAllSheets").always(function(){t.setSheetIndex(i)})},this.generateUpdateFormulaOperations=g.profileAsyncMethod("SpreadsheetModel.generateUpdateFormulaOperations()",function(t,n,r){var i=e.getStringOption(r,"drawingMode",null);return e.invokeChainedAsync("only"===i?null:function(){return ge.generateUpdateFormulaOperations(t,n)},function(){return te.generateOperationsForAllSheets(t,function(e){return e.generateUpdateFormulaOperations(t,n,i)},r)})}),this.generateInsertSheetOperations=function(e,t,n,r,i){return j(r).then(function(){var o={sheetName:r};n!==x.WORKSHEET&&(o.type=n.toJSON()),_.isObject(i)&&(o.attrs=i),e.setSheetIndex(t),e.generateSheetOperation(h.DELETE_SHEET,null,{undo:!0}),e.generateSheetOperation(h.INSERT_SHEET,o)})},this.generateDeleteSheetOperations=function(e,t){var n={type:M.DELETE_SHEET,sheet:t},r=this.generateUpdateFormulaOperations(e,n,{skipSheet:t});return(r=r.then(function(){return e.setSheetIndex(t),te.getSheetModel(t).generateRestoreOperations(e)})).done(function(){e.setSheetIndex(t),e.generateSheetOperation(h.DELETE_SHEET)})},this.generateMoveSheetOperations=function(e,t,n){return e.setSheetIndex(n).generateSheetOperation(h.MOVE_SHEET,{to:t},{undo:!0,prepend:!0}),e.setSheetIndex(t).generateSheetOperation(h.MOVE_SHEET,{to:n}),this.createResolvedPromise()},this.generateCopySheetOperations=function(e,t,n,r){return j(r).then(function(){var i={};te.getAllTables().forEach(function(e){i[e.getKey()]=!0});var o=te.getSheetModel(t),a={};o.getTableCollection().getAllTables().forEach(function(e){for(var t=e.getName(),n=/^(.*?)(\d+)$/.exec(t),r=n?n[1]:g.getTableName(),o=n?parseInt(n[2],10)+1:1;g.getTableKey(r+o)in i;)o+=1;var s=r+o;i[g.getTableKey(s)]=!0,a[t]=s});var s={to:n,sheetName:r};_.isEmpty(a)||(s.tableNames=a),e.setSheetIndex(t).generateSheetOperation(h.COPY_SHEET,s);var l=te.getSheetModel(n),u={type:M.RENAME_SHEET,sheet:t,sheetName:r,tableNames:a};e.setSheetIndex(n);var c=o.getDrawingCollection().createModelIterator({deep:!0,reverse:!0}),p=te.iterateSliced(c,function(t){"chart"!==t.getType()||t.isRestorable()||e.generateDrawingOperation(h.DELETE_DRAWING,t.getPosition())},"SpreadsheetModel.generateCopySheetOperations");return(p=p.then(function(){return l.generateUpdateFormulaOperations(e,u)})).done(function(){e.clearOperations({undo:!0}),e.generateSheetOperation(h.DELETE_SHEET,null,{undo:!0})})})},this.generateRenameSheetOperations=function(e,t,n){var r=this.getSheetName(t);return r===n?this.createResolvedPromise():j(n,t).then(function(){var i=new d(te),o={type:M.RENAME_SHEET,sheet:t,sheetName:n};return te.generateUpdateFormulaOperations(i,o).done(function(){e.setSheetIndex(t),e.generateSheetOperation(h.RENAME_SHEET,{sheetName:r},{undo:!0}),e.generateSheetOperation(h.RENAME_SHEET,{sheetName:n}),e.appendOperations(i,{undo:!0}),e.appendOperations(i)})})},se=new f(this),le=new R(this),ue=new A(this),ce=new O(this),he=new y(this),ge=new E(this),pe=new m(this),T.call(this),Ee=this.getNode()[0],(me=a.getPageContentNode(Ee)[0]).innerHTML="","ooxml"===ne&&(z(h.INSERT_NUMBER_FORMAT,se,"applyInsertOperation"),z(h.DELETE_NUMBER_FORMAT,se,"applyDeleteOperation")),this.registerContextOperationHandler(h.INSERT_SHEET,function(e){var t=e.getInt("sheet"),n=e.getStr("sheetName"),r=e.getOptEnum("type",x,x.WORKSHEET),i=e.getOptObj("attrs");e.ensure(!B,"debug mode: insert sheet fails"),e.ensure(t>=0&&t<=re.length,"invalid sheet index"),e.ensure(W(n),"invalid sheet name");var o=X(t,r,n,i);e.ensure(o,"cannot create sheet")}),J(h.DELETE_SHEET,function(e,t,n){e.ensure(re.length>1,"cannot delete last sheet"),te.trigger("delete:sheet:before",n,t);var r=te.getActiveSheet();n<r||n===r&&r+1===re.length?r-=1:r<n&&(r=-1),r>=0&&te.setActiveSheet(-1),n+1===re.length?ie.remove(t.getUid()):ie.clear(),me.removeChild(re[n].node),re.splice(n,1),t.destroy(),r>=0&&te.setActiveSheet(te.findVisibleSheet(r)),te.trigger("delete:sheet:after",n),te.trigger("transform:sheet",n,null)}),J(h.RENAME_SHEET,function(e,t,n){var r=P(n),i=e.getStr("sheetName");e.ensure(W(i,n),"invalid sheet name"),r.name!==i&&(r.name=i,te.trigger("rename:sheet",n,i,t))}),J(h.MOVE_SHEET,function(t,n,r){var i=t.getInt("to");t.ensure(i>=0&&i<=re.length,"invalid target index"),te.trigger("move:sheet:before",r,i,n);var o=te.getActiveSheet(),a=e.transformArrayIndex(o,r,i);o!==a&&te.setActiveSheet(-1);var s=re[r];re.splice(r,1),re.splice(i,0,s),me.removeChild(s.node),me.insertBefore(s.node,me.childNodes.item(i)),ie.clear(),o!==a&&te.setActiveSheet(a),te.trigger("move:sheet:after",r,i,n),te.trigger("transform:sheet",r,i)}),J(h.COPY_SHEET,function(e,t){var n=e.getInt("to");e.ensure(n>=0&&n<=re.length,"invalid target index");var r=e.getStr("sheetName");e.ensure(W(r),"invalid sheet name");var i=X(n,t.getType(),r);e.ensure(i,"cannot create sheet"),i.applyCopySheetOperation(e,t)}),function(e,t,n){J(e,function(e,n){n[t](e)},n)}(h.CHANGE_SHEET,"applyChangeSheetOperation"),q(h.CHANGE_CELLS,"getCellCollection","applyChangeCellsOperation"),q(h.INSERT_CELLS,"getCellCollection","applyInsertCellsOperation"),q(h.DELETE_CELLS,"getCellCollection","applyDeleteCellsOperation"),q(h.INSERT_HYPERLINK,"getHyperlinkCollection","applyInsertHyperlinkOperation"),q(h.DELETE_HYPERLINK,"getHyperlinkCollection","applyDeleteHyperlinkOperation"),q(h.MERGE_CELLS,"getMergeCollection","applyMergeCellsOperation"),q(h.INSERT_COLUMNS,"getColCollection","applyInsertOperation"),q(h.DELETE_COLUMNS,"getColCollection","applyDeleteOperation"),q(h.CHANGE_COLUMNS,"getColCollection","applyChangeOperation"),q(h.INSERT_ROWS,"getRowCollection","applyInsertOperation"),q(h.DELETE_ROWS,"getRowCollection","applyDeleteOperation"),q(h.CHANGE_ROWS,"getRowCollection","applyChangeOperation"),q(h.INSERT_NAME,"getNameCollection","applyInsertOperation",{allowDoc:!0}),q(h.DELETE_NAME,"getNameCollection","applyDeleteOperation",{allowDoc:!0}),q(h.CHANGE_NAME,"getNameCollection","applyChangeOperation",{allowDoc:!0}),q(h.INSERT_TABLE,"getTableCollection","applyInsertOperation"),q(h.DELETE_TABLE,"getTableCollection","applyDeleteOperation"),q(h.CHANGE_TABLE,"getTableCollection","applyChangeOperation"),q(h.CHANGE_TABLE_COLUMN,"getTableCollection","applyChangeColumnOperation"),q(h.INSERT_VALIDATION,"getValidationCollection","applyInsertOperation"),q(h.DELETE_VALIDATION,"getValidationCollection","applyDeleteOperation"),q(h.CHANGE_VALIDATION,"getValidationCollection","applyChangeOperation"),q(h.INSERT_CFRULE,"getCondFormatCollection","applyInsertOperation"),q(h.DELETE_CFRULE,"getCondFormatCollection","applyDeleteOperation"),q(h.CHANGE_CFRULE,"getCondFormatCollection","applyChangeOperation"),q(h.INSERT_COMMENT,"getCommentCollection","applyInsertCommentOperation"),q(h.DELETE_COMMENT,"getCommentCollection","applyDeleteCommentOperation"),q(h.CHANGE_COMMENT,"getCommentCollection","applyChangeCommentOperation"),Z(h.INSERT_DRAWING,"applyInsertDrawingOperation"),Z(h.DELETE_DRAWING,"applyDeleteDrawingOperation"),Z(h.MOVE_DRAWING,"applyMoveDrawingOperation"),ee(h.CHANGE_DRAWING,"applyChangeOperation"),ee(h.INSERT_CHART_DATASERIES,"applyInsertSeriesOperation",{type:"chart"}),ee(h.DELETE_CHART_DATASERIES,"applyDeleteSeriesOperation",{type:"chart"}),ee(h.SET_CHART_DATASERIES_ATTRIBUTES,"applyChangeSeriesOperation",{type:"chart"}),ee(h.SET_CHART_AXIS_ATTRIBUTES,"applyChangeAxisOperation",{type:"chart"}),ee(h.SET_CHART_GRIDLINE_ATTRIBUTES,"applyChangeGridOperation",{type:"chart"}),ee(h.SET_CHART_TITLE_ATTRIBUTES,"applyChangeTitleOperation",{type:"chart"}),ee(h.SET_CHART_LEGEND_ATTRIBUTES,"applyChangeLegendOperation",{type:"chart"}),ee(h.DELETE_CHART_AXIS,"applyDeleteAxisOperation",{type:"chart"}),this.waitForImport(function(){if(0!==re.length){re.forEach(function(e){e.model.initializeViewAttributes()});var t=e.minMax(this.getDocumentAttribute("activeSheet"),0,re.length-1),n=this.findVisibleSheet(t);n>=0&&this.setActiveSheet(n)}},this),this.listenTo(ge,"triggered",function(e,t){te.trigger.apply(te,[t,null].concat(_.toArray(arguments).slice(2)))}),G(this.getDocumentAttribute("cols"),this.getDocumentAttribute("rows")),this.on("change:attributes",function(e,t){G(t.cols,t.rows)}),this.on("change:sheet:attributes",function(e,t){var n=te.getActiveSheet();if(t===n&&!te.getSheetModel(t).isVisible()){var r=te.findVisibleSheet(n);r>=0&&te.setActiveSheet(r)}}),this.on("change:viewattributes",function(e,t){"activeSheet"in t&&Se()}),this.on("change:sheet:viewattributes",function(e,t,n){"selection"in n&&t===te.getActiveSheet()&&Se()}),this.on("operations:success",function(t,r){if(r.some(function(e){return e.name in U})){var i=_.pluck(re,"model"),o=new n("getUid()");e.iterateArray(r,function(e){if(e.name in U){var t=e.start;if(!_.isArray(t)||t.length<3)return;var n=i[t[0]];if(!n)return;var r=n.getDrawingCollection().getModelDescriptor(t.slice(1));if(!r||0===r.remaining.length)return;o.insert(r.model)}else switch(e.name){case h.INSERT_SHEET:i.splice(e.sheet,1);break;case h.DELETE_SHEET:i.splice(e.sheet,0,null);break;case h.MOVE_SHEET:i.splice(e.sheet,0,i.splice(e.to,1)[0]);break;case h.COPY_SHEET:i.splice(e.to,1)}},{reverse:!0}),o.forEach(function(e){e.getParentCollection().trigger("change:drawing:text",e)})}}),this.listenTo(Ee,"mousedown touchstart",function(){te.setActiveMouseDownEvent(!0)}),this.registerDestructor(function(){le.disconnect(),re.forEach(function(e){e.model.destroy()}),ge.destroy(),pe.destroy(),he.destroy(),ce.destroy(),ue.destroy(),le.destroy(),se.destroy(),oe.clear(),ae.clear(),V=te=re=ie=oe=ae=null,ue=ce=he=le=null,se=ge=pe=null,Ee=me=null})}})});