define("io.ox/office/spreadsheet/model/operationgenerator",["io.ox/office/tk/utils","io.ox/office/tk/container/valuemap","io.ox/office/editframework/utils/border","io.ox/office/editframework/model/operationgenerator","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils"],function(e,t,r,n,o,i){"use strict";var a=n.extend(function(r,o){n.call(this,r,o),this._autoStyles=r.getCellAutoStyles(),this._styleIdCache=new t,this._cacheHits=0,this._cacheMisses=0,this._sheet=e.getIntegerOption(o,"sheet",0)});return a.prototype._getCachedStyleId=function(e,t){var r=t?this._styleIdCache.get(t):null;if(!r)return null;var n=r.get(e,null);return null!==n&&(this._cacheHits+=1),n},a.prototype._setCachedStyleId=function(e,r,n){n&&(this._styleIdCache.getOrConstruct(n,t).insert(e,r),this._cacheMisses+=1)},a.prototype.getSheetIndex=function(){return this._sheet},a.prototype.setSheetIndex=function(e){return this._sheet=e,this},a.prototype.generateSheetOperation=function(e,t,r){return t=_.extend({sheet:this._sheet},t),this.generateOperation(e,t,r)},a.prototype.generateIntervalOperation=function(e,t,r,n){return r=_.extend({start:t.first},r),(t.first<t.last||n&&n.complete)&&(r.end=t.last),this.generateSheetOperation(e,r,n)},a.prototype.generateCellOperation=function(e,t,r,n){return r=_.extend({start:t.toJSON()},r),this.generateSheetOperation(e,r,n)},a.prototype.generateRangeOperation=function(e,t,r,n){return r=_.extend({start:t.start.toJSON()},r),(!t.single()||n&&n.complete)&&(r.end=t.end.toJSON()),this.generateSheetOperation(e,r,n)},a.prototype.generateRangesOperation=function(e,t,r,n){var o=n&&n.complete;return t=t.map(function(e){var t={start:e.start.toJSON()};return!o&&e.single()||(t.end=e.end.toJSON()),t}),r=_.extend({ranges:t.toJSON()},r),this.generateSheetOperation(e,r,n)},a.prototype.generateTableOperation=function(e,t,r,n){return t.length>0&&(r=_.extend({table:t},r)),this.generateSheetOperation(e,r,n)},a.prototype.generateDrawingOperation=function(e,t,r,n){return r=_.extend({start:[this._sheet].concat(t)},r),this.generateOperation(e,r,n)},a.prototype.generateMoveCellsOperation=function(e,t,r){return this.generateRangeOperation(o.MOVE_CELLS,e,{dir:t.toJSON()},r)},a.prototype.generateMergeCellsOperation=function(e,t,r){return this.generateRangeOperation(o.MERGE_CELLS,e,{type:t.toJSON()},r)},a.prototype.generateMoveDrawingOperation=function(e,t,r){return this.generateDrawingOperation(o.MOVE_DRAWING,e,{to:[this._sheet].concat(t)},r)},a.prototype.isDefaultStyleId=function(e){return this._autoStyles.isDefaultStyleId(e)},a.prototype.areEqualStyleIds=function(e,t){return this._autoStyles.areEqualStyleIds(e,t)},a.prototype.generateAutoStyle=function(t,r){if(!("s"in r||"a"in r||"format"in r||"table"in r))return t;var n=this._getCachedStyleId(t,r.cacheKey);if(null!==n)return n;if(n="string"==typeof r.s?r.s:t,_.isObject(r.a)||"format"in r||_.isObject(r.table)){var o=e.getFunctionOption(r,"processAttributes");n=this._autoStyles.generateAutoStyleOperation(this,n,r,o)}return this._setCachedStyleId(t,n,r.cacheKey),n},a.prototype.generateInsertedAutoStyle=function(e,t,n){function o(e,t,n){var o=e[t],i=e[n];return o&&i&&r.isEqual(o,i)}function a(e,t){var n=u[e],o=l[t];return n&&o&&r.isEqual(n,o)?n:null}if(this.areEqualStyleIds(e,t))return e;var s=e+"\n"+t,c=this._getCachedStyleId(e,s);if(null!==c)return c;var u=this._autoStyles.getBorderMap(e),l=this._autoStyles.getBorderMap(t);if(_.isEmpty(u)&&_.isEmpty(l))return e;var h={},p=i.getOuterBorderKey(!n,!0);h[i.getBorderName(p)]=a(p,p);var d=i.getOuterBorderKey(!n,!1);h[i.getBorderName(d)]=a(d,d);var f=i.getOuterBorderKey(n,!0),g=i.getOuterBorderKey(n,!1),y=a(g,f),O=y&&(o(u,f,g)||o(l,f,g));return h[i.getBorderName(f)]=h[i.getBorderName(g)]=O?y:null,this.generateAutoStyle(e,{a:{cell:h},cacheKey:s})},a.prototype.createBorderContents=function(){function e(e,t,n){var o=t.cell,a=e.cell;_.each("tblrdu",function(e){var t=i.getBorderName(e);if(t in a){var s=o[t],c=a[t];r.isVisibleBorder(c)||r.isVisibleBorder(s)&&!r.isEqual(s,n[t])||delete a[t]}})}var t={outer:1,inner:2,clear:3},n={t:1,b:4,l:16,r:64};return function(o,a){var s={},c={},u={},l=0;return o.forEach(function(e){var t=e.key,r=s[t]||(s[t]={});_.extend(r,e)}),_.each(s,function(e,o){var a=i.getBorderName(o),s=n[o];e.border?(c[a]=e.border,l|=s*t[e.cacheType]):e.keepBorder&&(c[a]=r.NONE,u[a]=e.keepBorder,l|=s*t.clear)}),{a:{cell:c},cacheKey:a+":"+l,processAttributes:function(t,r){return e(t,r,u)}}}}(),a.prototype.createVisibleBorderContents=function(){function e(e,t){var n=t.cell,o=e.cell;_.each("tblrdu",function(e){var t=i.getBorderName(e);if(t in o){var a=n[t],s=o[t];r.isVisibleBorder(a)?(s=_.extend({},a,s),o[t]=r.isVisibleBorder(s)?s:r.NONE):delete o[t]}})}var t={t:1,b:2,l:4,r:8,d:16,u:32};return function(r,n,o){var a={},s=0;return r.forEach(function(e){_.each(e.keys,function(e){a[i.getBorderName(e)]=n,s|=t[e]})}),{a:{cell:a},cacheKey:o+":"+s,processAttributes:e}}}(),a.prototype.logCacheUsage=i.isLoggingActive()?function(){var e=this._cacheHits+this._cacheMisses;e>0&&(i.log("style cache hits: "+this._cacheHits+" ("+Math.round(this._cacheHits/e*100)+"%)"),i.log("style cache miss: "+this._cacheMisses+" ("+Math.round(this._cacheMisses/e*100)+"%)"))}:_.noop,a});