define("io.ox/office/spreadsheet/utils/range",["io.ox/office/tk/utils","io.ox/office/tk/utils/class","io.ox/office/tk/utils/iterator","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address"],function(t,e,r,n,s){"use strict";var o=r.NestedIterator,i="("+s.COL_PATTERN+")("+s.ROW_PATTERN+")",a=new RegExp("^"+i+":"+i+"$","i"),u=e.extendable(function(t,e){this.start=t,this.end=e||t.clone()});return u.create=function(t,e,r,n){var o=new s(Math.min(t,r),Math.min(e,n)),i=new s(Math.max(t,r),Math.max(e,n));return new u(o,i)},u.createFromIntervals=function(t,e){return u.create(t.first,e.first,t.last,e.last)},u.createFromColInterval=function(t,e,r){return"number"!=typeof r&&(r=e),u.create(t.first,e,t.last,r)},u.createFromRowInterval=function(t,e,r){return"number"!=typeof r&&(r=e),u.create(e,t.first,r,t.last)},u.createFromAddresses=function(t,e){return e?u.create(t[0],t[1],e[0],e[1]):new u(t.clone())},u.createFromAddressAndSize=function(t,e,r){return u.create(t[0],t[1],t[0]+e-1,t[1]+r-1)},u.parse=function(t,e){var r=a.exec(t);if(!r)return null;var n=s.parseCol(r[1],e?e[0]:null),o=s.parseRow(r[2],e?e[1]:null),i=s.parseCol(r[3],e?e[0]:null),h=s.parseRow(r[4],e?e[1]:null);return Math.min(n,o,i,h)>=0?u.create(n,o,i,h):null},u.compare=function(e,r){return t.comparePairs(e.start,e.end,r.start,r.end,s.compare)},u.prototype.key=function(){return this.start.key()+":"+this.end.key()},u.prototype.clone=function(){return new u(this.start.clone(),this.end.clone())},u.prototype.equals=function(t){return this.start.equals(t.start)&&this.end.equals(t.end)},u.prototype.differs=function(t){return this.start.differs(t.start)||this.end.differs(t.end)},u.prototype.compareTo=function(t){return u.compare(this,t)},u.prototype.cols=function(){return this.end[0]-this.start[0]+1},u.prototype.rows=function(){return this.end[1]-this.start[1]+1},u.prototype.size=function(t){return t?this.cols():this.rows()},u.prototype.cells=function(){return this.cols()*this.rows()},u.prototype.singleCol=function(){return this.start[0]===this.end[0]},u.prototype.singleRow=function(){return this.start[1]===this.end[1]},u.prototype.singleLine=function(t){return t?this.singleCol():this.singleRow()},u.prototype.single=function(){return this.start.equals(this.end)},u.prototype.equalSize=function(t){return this.cols()===t.cols()&&this.rows()===t.rows()},u.prototype.sizeFitsInto=function(t){return t.cols()%this.cols()==0&&t.rows()%this.rows()==0},u.prototype.startsAt=function(t){return this.start.equals(t)},u.prototype.endsAt=function(t){return this.end.equals(t)},u.prototype.indexAt=function(t){return(t[1]-this.start[1])*this.cols()+(t[0]-this.start[0])},u.prototype.addressAt=function(t){var e=this.cols();return new s(this.start[0]+Math.floor(t%e),this.start[1]+Math.floor(t/e))},u.prototype.containsCol=function(t){return this.start[0]<=t&&t<=this.end[0]},u.prototype.containsRow=function(t){return this.start[1]<=t&&t<=this.end[1]},u.prototype.containsIndex=function(t,e){return e?this.containsCol(t):this.containsRow(t)},u.prototype.containsAddress=function(t){return this.containsCol(t[0])&&this.containsRow(t[1])},u.prototype.isBorderAddress=function(t){return this.containsAddress(t)&&(this.start[0]===t[0]||this.end[0]===t[0]||this.start[1]===t[1]||this.end[1]===t[1])},u.prototype.contains=function(t){return this.containsAddress(t.start)&&this.containsAddress(t.end)},u.prototype.overlaps=function(t){return this.start[0]<=t.end[0]&&t.start[0]<=this.end[0]&&this.start[1]<=t.end[1]&&t.start[1]<=this.end[1]},u.prototype.colInterval=function(){return new n(this.start[0],this.end[0])},u.prototype.rowInterval=function(){return new n(this.start[1],this.end[1])},u.prototype.interval=function(t){return t?this.colInterval():this.rowInterval()},u.prototype.colRange=function(t,e){var r=this.start[0]+t;return u.create(r,this.start[1],r+(e||1)-1,this.end[1])},u.prototype.rowRange=function(t,e){var r=this.start[1]+t;return u.create(this.start[0],r,this.end[0],r+(e||1)-1)},u.prototype.lineRange=function(t,e,r){return t?this.colRange(e,r):this.rowRange(e,r)},u.prototype.leadingCol=function(){return u.create(this.start[0],this.start[1],this.start[0],this.end[1])},u.prototype.trailingCol=function(){return u.create(this.end[0],this.start[1],this.end[0],this.end[1])},u.prototype.headerRow=function(){return u.create(this.start[0],this.start[1],this.end[0],this.start[1])},u.prototype.footerRow=function(){return u.create(this.start[0],this.end[1],this.end[0],this.end[1])},u.prototype.mirror=function(){return new u(this.start.mirror(),this.end.mirror())},u.prototype.expand=function(t){return u.create(Math.min(this.start[0],t[0]),Math.min(this.start[1],t[1]),Math.max(this.end[0],t[0]),Math.max(this.end[1],t[1]))},u.prototype.boundary=function(t){return u.create(Math.min(this.start[0],t.start[0]),Math.min(this.start[1],t.start[1]),Math.max(this.end[0],t.end[0]),Math.max(this.end[1],t.end[1]))},u.prototype.intersect=function(t){return this.overlaps(t)?u.create(Math.max(this.start[0],t.start[0]),Math.max(this.start[1],t.start[1]),Math.min(this.end[0],t.end[0]),Math.min(this.end[1],t.end[1])):null},u.prototype.getStart=function(t){return this.start.get(t)},u.prototype.getEnd=function(t){return this.end.get(t)},u.prototype.setStart=function(t,e){return this.start.set(t,e),this},u.prototype.setEnd=function(t,e){return this.end.set(t,e),this},u.prototype.setBoth=function(t,e){return this.start.set(t,e),this.end.set(t,e),this},u.prototype.moveBoth=function(t,e){return this.start.move(t,e),this.end.move(t,e),this},u.prototype.iterator=function(e){var r=t.getBooleanOption(e,"columns",!1),n=this.interval(r).iterator(e),i=this.interval(!r),a=i.iterator.bind(i,e);return new o(n,a,r?function(t,e){return{value:new s(t.value,e.value)}}:function(t,e){return{value:new s(e.value,t.value)}})},u.prototype.toString=function(){return this.start+":"+this.end},u.prototype.toJSON=function(){return{start:this.start.toJSON(),end:this.end.toJSON()}},u});