define("io.ox/office/spreadsheet/utils/sheetutils",["io.ox/office/tk/utils","io.ox/office/tk/utils/enum","io.ox/office/tk/utils/logger","io.ox/office/tk/locale/localedata","io.ox/office/tk/render/font","io.ox/office/spreadsheet/utils/errorcode","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/range3d","io.ox/office/spreadsheet/utils/addressarray","io.ox/office/spreadsheet/utils/intervalarray","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/utils/range3darray","io.ox/office/spreadsheet/utils/addressset","io.ox/office/spreadsheet/utils/intervalset","io.ox/office/spreadsheet/utils/rangeset","io.ox/office/spreadsheet/utils/changedescriptor","io.ox/office/spreadsheet/utils/movedescriptor","gettext!io.ox/office/spreadsheet/main"],function(e,t,r,o,n,i,a,s,f,d,l,u,c,g,p,h,x,A,T,C){"use strict";function E(e){return"rtl"===e?"right":"left"}var N={l:"borderLeft",r:"borderRight",t:"borderTop",b:"borderBottom",d:"borderDown",u:"borderUp",v:"borderInsideVert",h:"borderInsideHor"},O={left:"left",center:"center",right:"right",justify:"justify",distribute:"justify",fillAcross:"left",centerAcross:"center"},I={};r.extend(I,{enable:"spreadsheet:log-models",prefix:"MODEL"}),I.ErrorCode=i,I.Address=a,I.Interval=s,I.Range=f,I.Range3D=d,I.AddressArray=l,I.IntervalArray=u,I.RangeArray=c,I.Range3DArray=g,I.AddressSet=p,I.IntervalSet=h,I.RangeSet=x,I.ChangeDescriptor=A,I.MoveDescriptor=T,I.CELL_POOL_ID="cell",I.MAX_NAME_LENGTH=255,I.MAX_FILL_CELL_COUNT=2e4,I.MAX_AUTOFILL_COL_ROW_COUNT=100,I.MAX_MERGED_RANGES_COUNT=1e3,I.MAX_UNMERGE_CELL_COUNT=5e3,I.MAX_CHANGE_COLS_COUNT=5e3,I.MAX_CHANGE_ROWS_COUNT=5e3,I.MAX_SORT_LINES_COUNT=5e3,I.MAX_LENGTH_STANDARD_CELL=11,I.MAX_LENGTH_STANDARD_EDIT=21,I.MAX_LENGTH_STANDARD_FORMULA=20,I.MIN_CELL_SIZE=5,I.MULTI_SELECTION=!e.TOUCHDEVICE,I.SheetType=t.create("worksheet chartsheet macrosheet dialogsheet"),I.SplitMode=t.create("split frozen frozenSplit"),I.MoveMode=t.create("left right up down");var L=I.MergeMode=t.create("merge horizontal vertical unmerge");return I.UpdateMode=t.create("deleteSheet renameSheet relabelName moveCells cutPaste"),I.AnchorMode=t.create("absolute oneCell twoCell"),I.makeRejected=function(e){return(new $.Deferred).reject({cause:e})},I.getNameKey=function(e){return e.toUpperCase()},I.getTableKey=function(e){return e.toUpperCase()},I.getSheetName=function(e){return _.noI18n.fix(C("Sheet%1$d",_.noI18n(e)))},I.getTableName=function(){return _.noI18n.fix(C.pgettext("filter","Table"))},I.getTableColName=function(){return _.noI18n.fix(C.pgettext("filter","Column"))},I.hasWrappingAttributes=function(e){var t=e.cell;return t.wrapText||"justify"===t.alignHor||"justify"===t.alignVert},I.getTextOrientation=function(e,t,r){var i="string"==typeof r?n.getTextDirection(r):o.DIR,a=O[t];if(!a)switch(typeof e){case"string":a=E(e===r?i:n.getTextDirection(e));break;case"number":a="right";break;default:a=null===e?E(n.DEFAULT_TEXT_DIRECTION):"center"}return{textDir:i,cssTextAlign:a,baseBoxAlign:"justify"===a?E(i):a}},I.getOuterBorderKey=function(e,t){return e?t?"l":"r":t?"t":"b"},I.getInnerBorderKey=function(e){return e?"v":"h"},I.getBorderName=function(e){return N[e]},I.getOuterBorderName=function(e,t){return N[I.getOuterBorderKey(e,t)]},I.getInnerBorderName=function(e){return N[I.getInnerBorderKey(e)]},I.getTextPadding=function(e){return Math.ceil(e/4)},I.getTotalCellPadding=function(e){return 2*I.getTextPadding(e)+1},I.isOriginCell=function(e,t,r){switch(r){case L.MERGE:return t.startsAt(e);case L.HORIZONTAL:return t.start[0]===e[0];case L.VERTICAL:return t.start[1]===e[1]}return!1},I.getIteratorRanges=function(t,r){function o(e,t,r,o){var n=f.create(e,t,r,o);n.orig=u.orig,n.index=i,g.push(n)}var n=e.getBooleanOption(r,"reverse",!1),i=e.getIntegerOption(r,"startIndex",0),a=e.getOption(r,"startAddress",null),s=e.getBooleanOption(r,"skipStart",!1),d=e.getBooleanOption(r,"wrap",!1),l=c.map(t,function(e,t){var r=e.clone();return r.orig=e,r.index=t,r});if(!a&&0===i)return l;var u=l[i],g=new c;if(!n||d){if(a){var p=a[0]+(n!==s?1:0);p===u.start[0]?o(u.start[0],a[1],u.end[0],u.end[1]):(p<=u.end[0]&&o(p,a[1],u.end[0],a[1]),a[1]<u.end[1]&&o(u.start[0],a[1]+1,u.end[0],u.end[1]))}else n||g.push(u);g.append(l.slice(i+1))}if(n||d)if(g.append(l.slice(0,i)),a){var h=a[0]-(n===s?1:0);h===u.end[0]?o(u.start[0],u.start[1],u.end[0],a[1]):(u.start[1]<a[1]&&o(u.start[0],u.start[1],u.end[0],a[1]-1),u.start[0]<=h&&o(u.start[0],a[1],h,a[1]))}else n&&g.push(u);return g},I});