define("io.ox/office/textframework/utils/textutils",["io.ox/office/tk/utils","io.ox/office/tk/utils/logger","io.ox/office/tk/render/rectangle","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom"],function(t,e,n,r,i){"use strict";function o(t){function e(t){return parseInt(t.getAttribute("layer-order"),10)}return t.sort(function(t,n){return e(t)-e(n)}),t}function l(t,e){return new n(t.left-e.marginLeft,t.top-e.marginTop,t.width+e.marginLeft+e.marginRight,t.height+e.marginTop+e.marginBottom)}var a=_.clone(t),s=new RegExp("[ᄀ-ᇿ|㄰-㆏|ꥠ-꥿|가-힯|ힰ-퟿]"),u=new e({prefix:"TEXT",enable:"office:log-textutils"});a.DEFAULT_PAPER_FORMAT={en_US:"Letter",en_GB:"A4",de_DE:"A4",fr_FR:"A4",fr_CA:"Letter",es_ES:"A4",es_MX:"Letter",nl_NL:"A4",pl_PL:"A4",ja_JP:"A4",it_IT:"A4",zh_CN:"A4",zh_TW:"A4",hu_HU:"A4",sk_SK:"A4",cs_CZ:"A4",lv_LV:"A4",ro_RO:"A4",pt_BR:"Letter",sv_SE:"A4",da_DK:"A4",ru_RU:"A4"},a.MAC_COMPOSE_CHARS=["^","~","´","`"],a.NO_DRAWING_BACKGROUND={fill:{type:"none",color:null,color2:null,gradient:null,bitmap:null,pattern:null}},a.NO_SLIDE_BACKGROUND={fill:{type:null,color:null,color2:null,gradient:null,bitmap:null,pattern:null}};var f={Letter:{width:21590,height:27940},A4:{width:21e3,height:29700}};return a.indexOfValuesInsideTextSpan=function(e,n,r,i){var o=!1,l=0;if(t.getBooleanOption(i,"reverse",!1)){for(;n>=0&&!_.contains(r,e[n]);)n--;o=n>=0}else{for(l=e.length;n<l&&!_.contains(r,e[n]);)n++;o=n<l}return o?n:-1},a.mergeSiblingTextSpans=function(e,n){var o=null,l=null,a=null;(o=(e=t.getDomNode(e))[n?"nextSibling":"previousSibling"])&&i.isTextSpan(e)&&i.isTextSpan(o)&&r.hasEqualElementAttributes(e,o)&&(l=e.firstChild.nodeValue,a=o.firstChild.nodeValue,e.firstChild.nodeValue=n?l+a:a+l,$(o).remove())},a.getCSSPositionFromPoint=function(t,e,n){if(!t)return null;var r=$("<span>").text("|"),o=$(t.node.parentNode),l=parseFloat(o.css("line-height")),s=n/100;0===t.offset?o.before(r):(i.isSpan(o)&&i.splitTextSpan(o,t.offset,{append:!0}),o.after(r));var u=(r.offset().top-e.offset().top)/s-l+r.outerHeight(),f=(r.offset().left-e.offset().left)/s;return r.remove(),t.offset>0&&a.mergeSiblingTextSpans(o,!0),{top:u,left:f}},a.getCSSRectangleFromPoints=function(t,e,n,r,i){var o,l=document.createRange();if(l.setStart(t.node,t.offset),e)l.setEnd(e.node,e.offset);else if(t.offset+1<=t.node.length)l.setEnd(t.node,t.offset+1);else if(!i&&t.node.length>0)l.setStart(t.node,t.offset-1),l.setEnd(t.node,t.offset),o={top:(o=l.getBoundingClientRect()).top,left:o.right,height:o.height,width:0};else{var a=t.node.nextSibling;if(a)l.setEnd(a,0);else{var s=$(t.node.parentNode).offset().left+$(t.node.parentNode).width()*r;o={top:$(t.node.parentNode).offset().top,left:s,height:$(t.node.parentNode).height()*r,width:0}}}return o=o||l.getBoundingClientRect(),{top:(o.top-n.offset().top)/r,left:(o.left-n.offset().left)/r,height:o.height/r,width:o.width/r}},a.intervalOverlapsInterval=function(t,e){return t.first<=e.last&&e.first<=t.last},a.removeFalsyItemsInArray=function(t){return _.filter(t,function(t){return t})},a.calculateUserId=function(t){return _.isNumber(t)?10*(t+123)-123:null},a.resolveUserId=function(t){return _.isNumber(t)?(t+123)/10-123:null},a.getCharacterAttributesFromEmptyTextSpan=function(t){var e=null,n=null;return i.isParagraphNode(t)&&(e=i.findFirstPortionSpan(t),i.isEmptySpan(e)&&"character"in r.getExplicitAttributes(e)&&(n=r.getExplicitAttributes(e).character)),n},a.canMergeNeighboringOperations=function(){function t(t){return _.isObject(t.attrs)&&_.isObject(t.attrs.changes)}function e(t){return t.attrs&&t.attrs.changes&&t.attrs.changes.inserted&&t.attrs.changes.inserted.author}function n(t,n){var r=e(t),i=e(n);return _.isString(r)&&_.isString(i)&&r===i&&1===_.keys(n.attrs).length}return function(e,r){return!("attrs"in r)&&!t(e)||n(e,r)}}(),a.getAllAbsoluteDrawingsOnNode=u.profileMethod("TextUtils.getAllAbsoluteDrawingsOnNode()",function(t){return o(t.find(">.textdrawinglayer >.drawing.absolute, >.marginalcontent>.p .drawing.absolute"))}),a.getAllAbsoluteDrawingsOnPage=u.profileMethod("TextUtils.getAllAbsoluteDrawingsOnPage()",function(t,e){var n=".drawing.absolute:not(.grouped)",r=">.textdrawinglayer >"+n+'[page-number="'+e+'"]',i=t.find(r),l=t.find(".page-break"),a=$(l[e-2]),s=$(l[e-1]),u=null;if(a.length&&s.length||(u=t.find(">.pagecontent").children()),a.length){if(a.parent().is(".p")){var f=a.nextAll().find(n);i=i.add(f),a=a.parent()}}else a=$(u[0]);if(s.length){if(s.parent().is(".p")){var g=s.prevAll().find(n);i=i.add(g),s=s.parent()}}else s=$(_.last(u));var d=a.nextUntil(s).add(a).add(s).find(n);return i=i.add(d),o(i)}),a.findAllIntersections=u.profileMethod("TextUtils.findAllIntersections()",function(e,r,i){var o=$(e),a=e.getBoundingClientRect(),s=t.getStringOption(i,"marginKey",null),u=[];return a=s&&o.data(s)?l(a,o.data(s)):n.from(a),_.each(r,function(t){if(t!==e){var n=t.getBoundingClientRect();s&&$(t).data(s)&&(n=l(n,$(t).data(s))),a.overlaps(n)&&u.push(t)}}),u}),a.sortDrawingsOrder=function(t,e){_.each(t,function(t,n){var r=e+n;r!==t.style.zIndex&&(t.style.zIndex=r)})},a.getPageNumber=u.profileMethod("TextUtils.getPageNumber()",function(e,n){var r=e.getAttribute("page-number"),i=e.parentNode.classList.contains("textdrawinglayer");return r&&!i&&(t.error("drawing has attribute page number, but is a paragraph oriented drawing!!!"),r=null,e.setAttribute("page-number",null)),r?r=parseInt(r,10):(r=n.getPageLayout().getPageNumber(e),i&&e.setAttribute("page-number",r)),r}),a.isHangulText=function(t){return s.test(t)},a.getPaperSizeByLocale=function(t){var e=a.DEFAULT_PAPER_FORMAT[t];return(e?f[e]:null)||f.A4},a.getEmptyDrawingBackgroundAttributes=function(){return _.copy(a.NO_DRAWING_BACKGROUND,!0)},a.getEmptySlideBackgroundAttributes=function(){return _.copy(a.NO_SLIDE_BACKGROUND,!0)},a.convertAppContentBoxToPageBox=function(e,n){var r=e.getView().getZoomFactor(),i=e.getModel().getNode().offset(),o=e.getView().getContentRootNode(),l=o.offset(),a=o.scrollLeft(),s=o.scrollTop(),u={};return u.left=t.round((n.left-(i.left-l.left)-a)/r,1),u.top=t.round((n.top-(i.top-l.top)-s)/r,1),u.width=t.round(n.width/r,1),u.height=t.round(n.height/r,1),u},a});